#include "sys_config.h"
#if PRODUCT_WHYW
#include "sys_processor.h"
#include "UWater_eeprom_driver.h"
#include "UWater_timer1us_driver.h"
#include "UWater_rtcc_app.h"
#include "UWater_power_app.h"
#include "UWater_gp22_app.h"
#include "UWater_pt_app.h" 
#include "UWater_DataTools_App.h"
#include "UWater_QZ_Store_App.h"
#include "UWater_frame_func_ReplyWuHanYW.h"

/*------------------------------ Variable Define ------------------------------------*/
static u8 s_eep_complete_WHYW=0;
static u8 task_complete_WHYW = PTL_PACK_BUSY;   //Լ״̬
static u8 g_frame_temp_buf_WHYW[UP_BUF_SIZE];	//ݲֻ
static u16 g_frame_temp_len_WHYW=0;//ݲֵĳ

static STRUCT_FRAME_WHYW frame_struct_WHYW; //ԼϢṹ
static u8 *new_message_data_rev_WHYW;  //ָ
static u8 up_deal_stat_WHYW = UP_DEAL_S0;//Լ״̬
static DateTime whyw_protl_rtcc_time;
static u8 upload_count_flag=0;
//ϱʱر
static u32 temp_upload_delay_time;
static u32 temp_upload_set_time;
static u8 temp_upload_hour_minute_time;
/*******ϴݴ洢Ͷȡر*************************************/
static TYP_STATE_WHYW step_circle_data_store=WHYW_STATE_S0;
static U32_To_Float  temp_float_data;
static u32 temp_CircleData;//ݴ洢
static u16 uTemp_ee_addr;//洢ַ
static u8 uTemp_read_len;//洢ݳȱ
static UNION_2U8TOU16 u_circle_store_index_w;//ݴ洢λ
static UNION_2U8TOU16 u_circle_store_index_r;//ݶȡλ
static u8 upload_data_count;//֡¼
static u16 upload_packet_count;//ϱ֡
static u16 upload_packet_code;//֡
static u8 upload_packet_data_count;//֡¼
static u8 upload_circle_buf[UPLOAD_CIRCLE_MAX_LEN];//EEȡڼ¼Ļ
static DateTime upload_circle_rtcc_start;//һݵʼʱ
static DateTime upload_circle_rtcc_end;//ϱʱ
//static DateTime store_circle_rtcc_end;//ݴ洢һ¼ʱ
static UNION_4U8TOU32  temp_bcd_CircleData;//ϱʱ

static WHYW_UNION_EE_STORE whyw_ee;
/********ϴ֡ر************************************************/
static u8 upload_serial_num_sy=0;
static u8 temp_upload_step=0;
static u8 upload_frame_retry_times = 0;
static TYP_STATE_WHYW upload_frame_stat_whyw=WHYW_STATE_S0;
static u8 task_upload_complete_whyw = PTL_PACK_BUSY; //Լ״̬
static u8 g_upload_temp_buf_WHYW[300];	//ݲֻ,ʵõ244
static u16 g_upload_temp_len_WHYW=0;
static STRUCT_FRAME_WHYW upload_struct_WHYW; //ԼϢṹ
//ϱ֡
static UNION_2U8TOU16 temp_data_u16;
static u8 temp_data_u8;
static s16 s_temp_data=0;
static MET_STATE temp_state;
static u8 temp_buf1[16];
static u8 temp_buf2[16];
static u16 temp_data=0;
/***************************************************************
read_oline_time_ack
ˮʱȴʱ
˵:ˮʱʱ䵥λΪ룬1 ֽ HEX 룬14H ʾʱʱΪ 20 롣
****************************************************************/
static void read_oline_time_ack(void)
{
	g_frame_temp_len_WHYW=0;
	g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] =  whyw_ee.Data.ee_nb_online_keep_time;
    up_deal_stat_WHYW  = UP_DEAL_S0;
    task_complete_WHYW = PTL_PACK_SUCCESS;
}

/***************************************************************
read_meter_time_ack
ˮʵʱʱ
˵:ڡʱΪ 7 ֽ BCD 롣
****************************************************************/
static void read_meter_time_ack(void)
{
	DateTime tempRtccTime;
    RtccGetDateTime(&tempRtccTime); //ȡǰʱ
	
	g_frame_temp_len_WHYW=0;
    g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = tempRtccTime.s.second;
    g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = tempRtccTime.s.minute;
    g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = tempRtccTime.s.hour;
    g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = tempRtccTime.s.day;
    g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = tempRtccTime.s.month;
    g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = tempRtccTime.s.year;
    g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = 0x20;
	
    up_deal_stat_WHYW  = UP_DEAL_S0;
    task_complete_WHYW = PTL_PACK_SUCCESS;
}

/***************************************************************
read_upload_time
ˮԶϴݵʱ
****************************************************************/
static void read_upload_time(void)
{
	u8 temp_buf[64];
	u8 temp_index;
	DateTime tempDateTime;
	g_frame_temp_len_WHYW = 0;
	SystemGetUploadTime(&tempDateTime);//ȡϱʱ
	for (int i = 0; i < 48; i++)
    {
      temp_buf[i] = 0xFF;//ΪСʱϴ
    }
	temp_index = BCD2HEX(tempDateTime.s.hour)*2;
	temp_buf[temp_index] = BCD2HEX(tempDateTime.s.minute);
    for (int i = 0; i < 48; i++)
    {
      g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = temp_buf[i];
    }	
    up_deal_stat_WHYW  = UP_DEAL_S0;
    task_complete_WHYW = PTL_PACK_SUCCESS;
}
/***************************************************************
read_interval_time_ack
ȡˮݲɼʱ

˵:ˮɼݼʱֵֻΪ 0x010x050x0A0x0F0x140x1E0x3C  7 
ֵ(1 ӡ5 ӡ10 ӡ15 ӡ20 ӡ30 ӡ60 )ʱв
ݡҲɼʱķֵΪʼۼӲɼı
õķֵ
****************************************************************/
static void read_interval_time_ack(void)
{
	g_frame_temp_len_WHYW = 0;
    g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = whyw_ee.Data.ee_nb_acq_interval;

    up_deal_stat_WHYW  = UP_DEAL_S0;
    task_complete_WHYW = PTL_PACK_SUCCESS;
}
/***************************************************************
read_battery_ack
ȡصѹز

˵:ѹֵΪ 2 ֽ BCD 룬λֽǰλС:35H06H ʾѹ
ֵΪ 6.35V
****************************************************************/
static void read_battery_ack(void)
{
	g_frame_temp_len_WHYW = 0;
	//͵ѹֵ
	g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = whyw_ee.Data.ee_battery_pra[0];
	g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = whyw_ee.Data.ee_battery_pra[1];
	g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = whyw_ee.Data.ee_battery_pra[2];
	g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = whyw_ee.Data.ee_battery_pra[3];

    up_deal_stat_WHYW  = UP_DEAL_S0;
    task_complete_WHYW = PTL_PACK_SUCCESS;
}

/***************************************************************
read_nb_para_ack
ˮ NB 

IP ַͨ֡Ҫֱת 16 ƺٰҵ˳ͣ IP ַΪ
110.25.38.202ͨ֡ݼ˳Ϊ6EH19H26HCAH
˿ڵַͨ֡Ҫת 16 ƺٰλֽǰ˳ͣ˿ڵַΪ
5005ͨ֡ݼ˳Ϊ8DH13H
****************************************************************/
static void read_nb_para_ack(void)
{
	g_frame_temp_len_WHYW = 0;
	for (int i = 0; i < 4; i++)
	{
	   g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = Sys_data_object.P2.server_ip[i];
	}
	g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = Sys_data_object.P2.server_port.data_buf[0];
    g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = Sys_data_object.P2.server_port.data_buf[1];
	for(int i=6;i<0x38;i++)//
	{
		g_frame_temp_buf_WHYW[g_frame_temp_len_WHYW++] = 0x30;
	}			
	up_deal_stat_WHYW  = UP_DEAL_S0;
	task_complete_WHYW = PTL_PACK_SUCCESS;
}


/***************************************************************
write_online_time_ack
дˮʱȴʱ//68 10 03 00 08 22 20 33 78 04 04 00 81 11 22 0F 3B 16
˵:ͨѶ֡Ǹˮڲʵʱʱӽжʱˮʵʱʱݸʽǰͬ
****************************************************************/
static void write_online_time_ack(void)
{
    switch(up_deal_stat_WHYW)
    {
        case UP_DEAL_S0:
        {
            if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
            {
				g_frame_temp_len_WHYW = 0;
				if(*new_message_data_rev_WHYW > 30)
				{
					whyw_ee.Data.ee_nb_online_keep_time = 30;
				}
				else
				{
					whyw_ee.Data.ee_nb_online_keep_time = *new_message_data_rev_WHYW++;
				}
				EepWrite(&whyw_ee.Data.ee_nb_online_keep_time, EEP_ADDR_WHYW_NB_ONLINE_KEEP, 1, &s_eep_complete_WHYW);//EE
                up_deal_stat_WHYW  = UP_DEAL_S1;
            }
        }
        break;

        case UP_DEAL_S1:
        {
            if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
            {
				up_deal_stat_WHYW  = UP_DEAL_S0;
				task_complete_WHYW = PTL_PACK_SUCCESS;
            }
        }
        break;

        default:
        {
            up_deal_stat_WHYW  = UP_DEAL_S0;
            task_complete_WHYW = PTL_PACK_FAIL;
        }
        break;
    }
}

/***************************************************************
write_upload_time_ack
дˮԶϴݵʱ
˵:ͨѶ֡ΪˮߴͼϢݵʱݸʽǰ
ͨѶ֡һ¡
68 10 02 00 08 22 20 33 78 
44 //ctr
33 00 
81 04 
39 //ser
FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 
FF FF 0A FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF //110
7F 16
****************************************************************/
static void write_upload_time_ack(void)
{
    switch(up_deal_stat_WHYW)
    {
        case UP_DEAL_S0:
        {
            if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
            {
				g_frame_temp_len_WHYW = 0;
				
                temp_upload_delay_time = (u32)((Sys_data_object.P1.met_addr[1] & 0x0F)) * 100;
				temp_upload_delay_time += (Sys_data_object.P1.met_addr[0] >> 4) * 10 + (Sys_data_object.P1.met_addr[0] & 0x0F);	//ַλ0-999
				temp_upload_delay_time *= Sys_data_object.P1.report_step_len.datas;	//ɢϵ
				for(int i=0;i<48;i++)
				{
					temp_upload_hour_minute_time = *new_message_data_rev_WHYW++;
					if(0xFF != temp_upload_hour_minute_time)
					{
						temp_upload_set_time = (i/2)*3600+temp_upload_hour_minute_time*60;
						if(temp_upload_set_time>temp_upload_delay_time)
						{
							temp_upload_set_time -= temp_upload_delay_time;
						}
						else
						{
							temp_upload_set_time = 0;
						}
						Sys_data_object.P1.Time_upload_2006.s.type = UPLOAD_MODE_DAY;
						Sys_data_object.P1.Time_upload_2006.s.hour = HEX2BCD(temp_upload_set_time/3600);
						Sys_data_object.P1.Time_upload_2006.s.minute = HEX2BCD((temp_upload_set_time%3600)/60);
						EepWrite(&Sys_data_object.P1.Time_upload_2006.buf[0], FRAME_NBIot_FREQVAL, 5, &s_eep_complete_WHYW);//EE
						Frame_Para_Init();
						break;
					}
				}
                up_deal_stat_WHYW  = UP_DEAL_S1;
            }
        }
        break;

        case UP_DEAL_S1:
        {
            if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
            {
				up_deal_stat_WHYW  = UP_DEAL_S0;
				task_complete_WHYW = PTL_PACK_SUCCESS;
            }
        }
        break;

        default:
        {
            up_deal_stat_WHYW  = UP_DEAL_S0;
            task_complete_WHYW = PTL_PACK_FAIL;
        }
        break;
    }
}

/***************************************************************
write_interval_time_ack
дˮݲɼʱ
˵:ͨѶ֡ΪˮݲɼʱݸʽǰͨѶ֡
һ¡
****************************************************************/
static void write_interval_time_ack(void)
{
    switch(up_deal_stat_WHYW)
    {
        case UP_DEAL_S0:
        {
            if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
            {
				g_frame_temp_len_WHYW = 0;
                whyw_ee.Data.ee_nb_acq_interval = *new_message_data_rev_WHYW++;
				EepWrite(&whyw_ee.Data.ee_nb_acq_interval, EEP_ADDR_WHYW_STORE_INTERVAL, 1, &s_eep_complete_WHYW);//EE
                up_deal_stat_WHYW  = UP_DEAL_S1;
            }
        }
        break;

        case UP_DEAL_S1:
        {
            if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
            {
				up_deal_stat_WHYW  = UP_DEAL_S0;
				task_complete_WHYW = PTL_PACK_SUCCESS;
            }
        }
        break;

        default:
        {
            up_deal_stat_WHYW  = UP_DEAL_S0;
            task_complete_WHYW = PTL_PACK_FAIL;
        }
        break;
    }
}

/***************************************************************
write_battery_ack
дصѹز
˵:ͨѶ֡Ϊˮʱĵѹֵ͵ľʱĵѹֵ
ʽǰͨѶ֡һ¡
****************************************************************/
static void write_battery_ack(void)
{
    switch(up_deal_stat_WHYW)
    {
        case UP_DEAL_S0:
        {
            if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
            {
				g_frame_temp_len_WHYW = 0;
				whyw_ee.Data.ee_battery_pra[0] = *new_message_data_rev_WHYW++;
				whyw_ee.Data.ee_battery_pra[1] = *new_message_data_rev_WHYW++;
				whyw_ee.Data.ee_battery_pra[2] = *new_message_data_rev_WHYW++;
				whyw_ee.Data.ee_battery_pra[3] = *new_message_data_rev_WHYW++;
				EepWrite(whyw_ee.Data.ee_battery_pra, EEP_ADDR_WHYW_BATTERY_PRA, 4, &s_eep_complete_WHYW);//EE
                up_deal_stat_WHYW  = UP_DEAL_S1;
            }
        }
        break;

        case UP_DEAL_S1:
        {
            if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
            {
				up_deal_stat_WHYW  = UP_DEAL_S0;
				task_complete_WHYW = PTL_PACK_SUCCESS;
            }
        }
        break;

        default:
        {
            up_deal_stat_WHYW  = UP_DEAL_S0;
            task_complete_WHYW = PTL_PACK_FAIL;
        }
        break;
    }
}

/***************************************************************
write_nb_para_ack
дˮ NB 
˵:ͨѶ֡Ϊˮʱ NB (IP ַ˿)ݸʽǰ
ͨѶ֡һ
****************************************************************/
static void write_nb_para_ack(void)
{
    switch(up_deal_stat_WHYW)
    {
        case UP_DEAL_S0:
        {
			if(TASK_IDLE == EepIfIdle())
			{
				g_frame_temp_len_WHYW = 0;
				for (int i = 0; i < 4; i++)
				{
				    Sys_data_object.P2.server_ip[i] = *(new_message_data_rev_WHYW +i);
				}
				Sys_data_object.P2.server_port.data_buf[0] = *(new_message_data_rev_WHYW +4);
				Sys_data_object.P2.server_port.data_buf[1] = *(new_message_data_rev_WHYW +5);
				EepWrite(&Sys_data_object.P2.server_ip[0], EEP_UPDATE_UDP_IP, 6, &s_eep_complete_WHYW);//浽UDP IP
				up_deal_stat_WHYW  = UP_DEAL_S1;
			}
        }
        break;

        case UP_DEAL_S1:
        {
			if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM   
			{
				up_deal_stat_WHYW  = UP_DEAL_S0;
				task_complete_WHYW = PTL_PACK_SUCCESS;
			}
        }
        break;

        default:
        {
            up_deal_stat_WHYW  = UP_DEAL_S0;
            task_complete_WHYW = PTL_PACK_FAIL;
        }
        break;
    }
}

/***************************************************************
upload_ack
ϱӦ֡
˵:NB ˮߺͼϢͨѶ֡ƽ̨յϢ֡Ӧ
ͨѶ֡ƽ̨ԸˮزûʱӦΪ 01Hˮ
յӦʱɽ롰ߡ״̬ƽ̨ҪԸˮزʱƽ̨Ӧ
Ϊ 41H(D6 Ϊ1)ˮʱҪеȴƽ̨ĺָ֡(ݲ
ȴʱ䣬ʱδյƽ̨κͨѶ֡롰ߡ״̬)ƽ̨·ͨѶ֡
(D6 Ϊ1)ͬ
//68 10 02 00 08 22 20 33 78 01 07 00 90 20 14 01 00 01 00 3D 16
****************************************************************/
static void upload_ack(void)
{
	if(frame_struct_WHYW.serial_num == upload_serial_num_sy)//Ƚк
	{
		FrameSetMsgApp(MsgNbUplaod_AckOk);
	}
	g_frame_temp_len_WHYW = 0;
	up_deal_stat_WHYW  = UP_DEAL_S0;
	task_complete_WHYW = PTL_PACK_FAIL;
}
/****************************************************************************************************/
//ַж
static u8 check_met_addr_WHYW(u8 * p_buf)
{
    u8 tmp_i = 0;
    u8 tmp_arry[8];

    for (tmp_i = 0; tmp_i < 8; tmp_i++)
    {
        tmp_arry[tmp_i] = *(p_buf + tmp_i + 1);
    }

    for (tmp_i = 1; tmp_i < 8; tmp_i++)
    {
        if ((tmp_arry[tmp_i] != Sys_data_object.P1.met_addr[tmp_i - 1]) && (tmp_arry[tmp_i] != 0xAA))
        {
            return ERROR_IES;
        }
    }

    return SUCCESS_IES;
}
//Լ
u8 crack_frame_WHYW(u16 frame_lenth, u8 *frame_buffer)
{
    u16 i;
    u16 j;
    u16 endloc = 0;
    u16 framelen = 0;

    if(*(frame_buffer + 10) != 1)
    {
        if (frame_lenth > FRAME_LEN_MAX) //֡Ƿݻ
        {
            return (ERROR_IES);
        }

        if (frame_lenth < FRAME_LEN_MIN) //֡ǷССЭ֡
        {
            return (ERROR_IES);
        }

        for (i = 0; i < frame_lenth; i++)
        {
            if (FRAME_HEAD == *frame_buffer) //ҵ֡ͷ
            {
				frame_struct_WHYW.head_site = i; //¼֡ͷ
                if (ERROR_IES == check_met_addr_WHYW(frame_buffer)) //ָĵַͱַǷͬͬ1ͬ0
                {
                    return (ERROR_IES);
                }

                frame_struct_WHYW.len.to_uint8[0] = *(frame_buffer + 10); 	//
                frame_struct_WHYW.len.to_uint8[1] = *(frame_buffer + 11); 	//

                framelen = frame_struct_WHYW.len.to_uint16 + 14; 			//֡ 

                if (frame_struct_WHYW.len.to_uint16 > (frame_lenth - i))	//ֹͨѶԼǡƹԽ縴λ
                {
                    return (ERROR_IES);
                }

                endloc = framelen - 1;

                if ((FRAME_TAIL == frame_buffer[endloc]) && (endloc <= frame_lenth)) //ȷ֡Ч
                {
                    frame_struct_WHYW.chkval = 0;

                    for (j = 0; j < (framelen - 2); j++)
                    {
                        frame_struct_WHYW.chkval = frame_struct_WHYW.chkval + frame_buffer[j]; //У
                    }

                    frame_struct_WHYW.chkval &= 0x00ff;

                    if (frame_struct_WHYW.chkval == frame_buffer[endloc - 1])
                    {
                        frame_struct_WHYW.frame_ctrl = *(frame_buffer + 9);  //ȡ
                        frame_struct_WHYW.mark_DI0 = *(frame_buffer + 12);
                        frame_struct_WHYW.mark_DI1 = *(frame_buffer + 13);
                        frame_struct_WHYW.serial_num = *(frame_buffer + 14);
                        //68 10 03 00 08 22 20 33 78 04 04 00 81 11 22 0F 3B 16
						new_message_data_rev_WHYW = frame_buffer + frame_struct_WHYW.head_site + 15;	
						FrameSetMsgApp(MsgNb_FlagRcvNbFrame);  //ָʱϢ
                        return (SUCCESS_IES);
                    }//end if
                }
            }//end ֡ͷif

            frame_buffer++;
        }//end for()

        return (ERROR_IES);
    }
    return ERROR_IES;
}

//Լ
static u8 whyw_deal_ctrl=0;
static u8 whyw_online_wait_flag=0;
u8 up_deal_code_WHYW(void)
{
	task_complete_WHYW = PTL_PACK_BUSY;
	whyw_deal_ctrl = (frame_struct_WHYW.frame_ctrl&0xBF);//ȥD6ˮߵȴλ
	if(frame_struct_WHYW.frame_ctrl&0x40)//жǷߵȴ
	{
		whyw_online_wait_flag = 1;//ʱϢ
	}
	else
	{
		whyw_online_wait_flag = 2;//Ϣ
	}
	switch(whyw_deal_ctrl)
	{
		case READ_CTRL_DOWN:
		{
			//ˮʱȴʱ
			if((frame_struct_WHYW.mark_DI0 == RW_ONLINE_TIME_D0)&&(frame_struct_WHYW.mark_DI1 == RW_ONLINE_TIME_D1))
			{
				 read_oline_time_ack();
			}
			//ˮʵʱʱ
			else if((frame_struct_WHYW.mark_DI0 == RW_METER_TIME_D0)&&(frame_struct_WHYW.mark_DI1 == RW_METER_TIME_D1))
			{
				read_meter_time_ack();
			}
			//ˮԶϴݵʱ
			else if((frame_struct_WHYW.mark_DI0 == RW_UPLOAD_TIME_ID0)&&(frame_struct_WHYW.mark_DI1 == RW_UPLOAD_TIME_ID1))
			{
				read_upload_time();
			}
			//ȡˮݲɼʱ
			else if((frame_struct_WHYW.mark_DI0 == RW_INTERVAL_TIME_ID0)&&(frame_struct_WHYW.mark_DI1 == RW_INTERVAL_TIME_ID1))
			{
				read_interval_time_ack();
			}
			//ȡصѹز
			else if((frame_struct_WHYW.mark_DI0 == RW_BATTERY_D0)&&(frame_struct_WHYW.mark_DI1 == RW_BATTERY_D1))
			{
				read_battery_ack();
			}
			//ˮ NB 
			else if((frame_struct_WHYW.mark_DI0 == RW_NB_PARA_D0)&&(frame_struct_WHYW.mark_DI1 == RW_NB_PARA_D1))
			{
				read_nb_para_ack();
			}
			//ˮ͵ǰļϢӦ֡
			else if((frame_struct_WHYW.mark_DI0 == UPLOAD_DATA_D0)&&(frame_struct_WHYW.mark_DI1 == UPLOAD_DATA_D1))
			{
				upload_ack();
			}
			else
			{
				g_frame_temp_len_WHYW = 0;
				up_deal_stat_WHYW  = UP_DEAL_S0;
				task_complete_WHYW = PTL_PACK_FAIL;
			}
			frame_struct_WHYW.ack_ctrl = READ_CTRL_UP;
		}
		break;
		case WRITE_CTRL_DOWN:
		{
			//дˮʱȴʱ
			if((frame_struct_WHYW.mark_DI0 == RW_ONLINE_TIME_D0)&&(frame_struct_WHYW.mark_DI1 == RW_ONLINE_TIME_D1))
			{
				write_online_time_ack();
			}
			//дˮʵʱʱ
			else if((frame_struct_WHYW.mark_DI0 == RW_METER_TIME_D0)&&(frame_struct_WHYW.mark_DI1 == RW_METER_TIME_D1))
			{
				task_complete_WHYW = PTL_PACK_FAIL;
			}
			//дˮԶϴݵʱ
			else if((frame_struct_WHYW.mark_DI0 == RW_UPLOAD_TIME_ID0)&&(frame_struct_WHYW.mark_DI1 == RW_UPLOAD_TIME_ID1))
			{
				write_upload_time_ack();
			}
			//дˮݲɼʱ
			else if((frame_struct_WHYW.mark_DI0 == RW_INTERVAL_TIME_ID0)&&(frame_struct_WHYW.mark_DI1 == RW_INTERVAL_TIME_ID1))
			{
				write_interval_time_ack();
			}
			//дصѹز
			else if((frame_struct_WHYW.mark_DI0 == RW_BATTERY_D0)&&(frame_struct_WHYW.mark_DI1 == RW_BATTERY_D1))
			{
				write_battery_ack();
			}
			//дˮ NB 
			else if((frame_struct_WHYW.mark_DI0 == RW_NB_PARA_D0)&&(frame_struct_WHYW.mark_DI1 == RW_NB_PARA_D1))
			{
				write_nb_para_ack();
			}
			else
			{
				g_frame_temp_len_WHYW = 0;
				up_deal_stat_WHYW  = UP_DEAL_S0;
				task_complete_WHYW = PTL_PACK_FAIL;
			}
			frame_struct_WHYW.ack_ctrl = WRITE_CTRL_UP;
		}
		break;
		default:
        {    
			g_frame_temp_len_WHYW = 0;
			up_deal_stat_WHYW  = UP_DEAL_S0;
			task_complete_WHYW = PTL_PACK_FAIL;         
        }
        break;
	}
    return task_complete_WHYW;
}

void Frame_ResetDealState_WHYW(void)
{
	up_deal_stat_WHYW = UP_DEAL_S0;
}
//֡
static void Frame_ack_WHYWBase(STRUCT_FRAME_WHYW temp_struct, u8* p_temp_buf, u16 p_temp_len, u8* p_send_buf, u16* p_send_len)
{
    u16 i = 0;
	u8 temp_cs;
	u8* p_send_buf_start;
	u8* p_send_buf_end;
	u16 temp_len;
	
	p_send_buf_start = p_send_buf;
	p_send_buf_end = p_send_buf;
	
    *p_send_buf_end++ = FRAME_HEAD_MARK;
    *p_send_buf_end++ = W_METTYPE;
    for (i = 0; i < 7; i++)
    {
        *p_send_buf_end++ = Sys_data_object.P1.met_addr[i];	//ַ
    }
    *p_send_buf_end++ = temp_struct.ack_ctrl;
    *p_send_buf_end++ = (p_temp_len+3)&0xFF; // ֽڣdi0di1ser
    *p_send_buf_end++ = ((p_temp_len+3)>>8)&0xFF;
    *p_send_buf_end++ = temp_struct.mark_DI0;
    *p_send_buf_end++ = temp_struct.mark_DI1;
    *p_send_buf_end++ = temp_struct.serial_num;
	//
    for(i = 0; i < p_temp_len; i++)
    {
        *p_send_buf_end++ = *(p_temp_buf + i);	
    }
	//У
	temp_len = (p_send_buf_end - p_send_buf_start);
    for(i = 0; i < temp_len; i++)		
    {
        temp_cs += *p_send_buf_start;
		p_send_buf_start++;
    }
	*p_send_buf_end++ = temp_cs;
	*p_send_buf_end++ = FRAME_END_MARK;
	*p_send_len = (temp_len+2);
}
//Ӧ֡
void Frame_ack_WHYW(u8* p_send_buf, u16* p_send_len)
{
	Frame_ack_WHYWBase(frame_struct_WHYW, g_frame_temp_buf_WHYW, g_frame_temp_len_WHYW, p_send_buf, p_send_len);
}
/****************************************************************ϱݵĴ*********************************************/
//ϱ֡
void Frame_upload_WHYW(u8* p_send_buf, u16* p_send_len)
{
	upload_struct_WHYW.ack_ctrl = READ_CTRL_UP;
	upload_struct_WHYW.mark_DI0 = UPLOAD_DATA_D0;
    upload_struct_WHYW.mark_DI1 = UPLOAD_DATA_D1;
	upload_serial_num_sy++;//к
	upload_struct_WHYW.serial_num = upload_serial_num_sy;
	
	Frame_ack_WHYWBase(upload_struct_WHYW, g_upload_temp_buf_WHYW, g_upload_temp_len_WHYW, p_send_buf, p_send_len);
}

//UDPϱ֡
void Upload_FrameData(void)
{
    g_upload_temp_len_WHYW = 0;
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_packet_count&0xFF; //֡L
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = (upload_packet_count>>8)&0xFF; //֡H
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_packet_code&0xFF; //֡L
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = (upload_packet_code>>8)&0xFF; //֡H
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_packet_data_count; //֡
	
	/***EEȡ***/
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_circle_rtcc_start.s.minute; //ݲɼʱ-
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_circle_rtcc_start.s.hour; //ݲɼʱ-ʱ
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_circle_rtcc_start.s.day; //ݲɼʱ-
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_circle_rtcc_start.s.month; //ݲɼʱ-
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_circle_rtcc_start.s.year; //ݲɼʱ-
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = 30 ; //ɼ30

	//ǰۼ(4 ֽ BCD ) :50H56H34H12H ʾǰۻΪ 123456.50 m3
	for(int i=0;i<upload_packet_data_count;i++)
	{
		g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_circle_buf[4*i+0];
		g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_circle_buf[4*i+1];
		g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_circle_buf[4*i+2];
		g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = upload_circle_buf[4*i+3];
	}
	//35H06H ʾѹֵΪ 6.35V
	temp_data_u16.datas = HexToBcd16(PowerCheckValueSys());		
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_data_u16.data_buf[0];//صѹL
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_data_u16.data_buf[1];//صѹH

	 //CSQ BCDʽ
	NbiotGetCSQ(&temp_data_u8);
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = HEX2BCD(temp_data_u8);//sys_get_single.to_uint8[0];
	
	//ȡRSRP hex 2 ֽ,λʾλ0ʾ1ʾD0-D14 ʾźֵ7BH80H ʾźֵΪ-123dBm
	NbiotGetRSRP(&s_temp_data);
	temp_data_u16.datas = -(s_temp_data/10);
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_data_u16.data_buf[0];
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_data_u16.data_buf[1]|0x80;

    //ȡSNR hex  19H00H ʾ 25dB
	NbiotGetSNR(&s_temp_data);
	if(s_temp_data<0)
	{
		temp_data_u16.datas = (-s_temp_data/10)|0x8000;
	}
	else
    {
	    temp_data_u16.datas = s_temp_data/10;
	}
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_data_u16.data_buf[0];
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_data_u16.data_buf[1];

    //ȡECL
	NbiotGetECL(&s_temp_data);
	temp_data_u16.datas = s_temp_data;
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_data_u16.data_buf[0];
	
	//PCI  2 ֽ BCD 룬λֽǰ05H04H  ʾ PCI Ϊ 504
    NbiotGetPCI(&temp_data);
	temp_data_u16.datas = temp_data;
	temp_data_u16.datas = HexToBcd16(temp_data_u16.datas);
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_data_u16.data_buf[0];
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_data_u16.data_buf[1];

	//IMEI  : 08H23H25H89H67H31H09H60H ʾ NB ģ IMEI Ϊ 823258967310960
	NbiotGetIMEI((char*)temp_buf1); 
	temp_buf2[0] = temp_buf1[0] - 0x30;
	for(int i=1;i<8;i++)
	{
		temp_buf2[i]  =  (temp_buf1[2*i]-0x30)&0x0F;
		temp_buf2[i] |= ((temp_buf1[2*i-1]-0x30)<<4)&0xF0;          
	}
	for(int i = 0; i < 8; i++)
	{
		g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_buf2[i];;
	}
	//IMSI : 09H12H34H79H68H56H07H80H ʾ SIM  IMSI Ϊ 912347968560780
	NbiotGetIMSI((char*)temp_buf1); 
	temp_buf2[0] = temp_buf1[0] - 0x30;
	for(int i=1;i<8;i++)
	{
		temp_buf2[i]  =  (temp_buf1[2*i]-0x30)&0x0F;
		temp_buf2[i] |= ((temp_buf1[2*i-1]-0x30)<<4)&0xF0;          
	}
	for(int i = 0; i < 8; i++)
	{
		g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_buf2[i];
	}				
	//߳ɹ/ʧܴ	
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = whyw_ee.Data.ee_upload_count_success.data_buf[0];
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = whyw_ee.Data.ee_upload_count_success.data_buf[1];
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = whyw_ee.Data.ee_upload_count_fail.data_buf[0];
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = whyw_ee.Data.ee_upload_count_fail.data_buf[1];
	//ʱ
	DateTime sys_rtcc_time;
    RtccGetDateTime(&sys_rtcc_time);
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = sys_rtcc_time.s.second;
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = sys_rtcc_time.s.minute;
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = sys_rtcc_time.s.hour;
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = sys_rtcc_time.s.day;
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = sys_rtcc_time.s.month;
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = sys_rtcc_time.s.year;
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = 0x20;
    //״̬Ϣ
		temp_data_u8 = 0;
	if(UPLOAD_TYPE_FIX_TIME == GetEventUploadType()|| (UPLOAD_TYPE_RETRY_AGAIN == GetEventUploadType()))//ʱϴ
	{
		temp_data_u8 &=~ 0x80;//Զ
	}
	else
	{
		temp_data_u8 |= 0x80;//
	}
	temp_state = FrameGetByte();
	if(temp_state.stat1bits.low_battery_voltage)
	{
		temp_data_u8 |= 0x04;//Ƿѹ
	}
	else
	{
		temp_data_u8 &=~0x04;//
	}
	temp_data_u8 &=~ 0x02;//巧Źϱ־
	if(temp_state.stat1bits.valve_state==0)
	{
		temp_data_u8 &=~ 0x01;//
	}
	else if(temp_state.stat1bits.valve_state==1)
	{
		temp_data_u8 |= 0x01;//ط
	}
	else
	{
		temp_data_u8 |= 0x02;//
	}
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = temp_data_u8;//state0;
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = 0x03;//state1; 03H:ˮ
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = 3;//warning0;
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = 4;//warning1;
    g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = 5;//warning2;
	//Ӳ汾
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = HARDWARE_VERSION_USED;
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = 0;
	//汾
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = (PROGRAME_VERSION>>16)&0xFF;
	g_upload_temp_buf_WHYW[g_upload_temp_len_WHYW++] = (PROGRAME_VERSION>>24)&0xFF;
}

/********************************************************************************
GetCircleDateTimeStart
˵  ݲɼݼ¼ʼʱ
********************************************************************************/
u8 GetCircleDateTimeStart(DateTime* startTime, DateTime endTime, u32 dataCnt, u8 intervalTime)
{
	struct tm tmdt;
	struct tm *ldt;
	time_t ctt;

	tmdt.tm_year = (endTime.s.year >> 4) * 10 + (endTime.s.year & 0x0F) + 100;
	tmdt.tm_mon = (endTime.s.month >> 4) * 10 + (endTime.s.month & 0x0F) - 1;
	tmdt.tm_mday = (endTime.s.day >> 4) * 10 + (endTime.s.day & 0x0F);
	tmdt.tm_hour = (endTime.s.hour >> 4) * 10 + (endTime.s.hour & 0x0F);
	tmdt.tm_min = (endTime.s.minute >> 4) * 10 + (endTime.s.minute & 0x0F);
	tmdt.tm_sec = (endTime.s.second >> 4) * 10 + (endTime.s.second & 0x0F);
	tmdt.tm_isdst = 0;
	ctt = mktime(&tmdt);
	ctt -= (dataCnt*intervalTime*60);
	ldt = localtime(&ctt);

	startTime->s.year = ((*ldt).tm_year - 100) / 10 * 16 + ((*ldt).tm_year - 100) % 10;
	startTime->s.month = ((*ldt).tm_mon + 1) / 10 * 16 + ((*ldt).tm_mon + 1) % 10;
	startTime->s.day = ((*ldt).tm_mday) / 10 * 16 + ((*ldt).tm_mday) % 10;
	startTime->s.weekday = ((*ldt).tm_wday) / 10 * 16 + ((*ldt).tm_wday) % 10;
	startTime->s.hour = ((*ldt).tm_hour) / 10 * 16 + ((*ldt).tm_hour) % 10;
	startTime->s.minute = ((*ldt).tm_min) / 10 * 16 + ((*ldt).tm_min) % 10;
	startTime->s.second = ((*ldt).tm_sec) / 10 * 16 + ((*ldt).tm_sec) % 10;
	
	return Rtcc_Check_DateTime(startTime);
}

void GetUploadDataResetState_WHYW(void)
{
	upload_frame_stat_whyw =WHYW_STATE_S0;
	task_upload_complete_whyw = PTL_PACK_BUSY;
}
u8 GetUploadDataCheckIdle_WHYW(void)
{
	if(WHYW_STATE_S0 == upload_frame_stat_whyw)
    {
        return TASK_IDLE;
    }
    else
    {
        return TASK_BUSY;
    }
}
u8 GetUploadDataCheckTask_WHYW(void)
{
	return task_upload_complete_whyw;
}

int GetUploadDataCount(void)
{
	if (whyw_ee.Data.u_circle_store_index_w.datas >= whyw_ee.Data.u_circle_store_index_r.datas)
		return (whyw_ee.Data.u_circle_store_index_w.datas - whyw_ee.Data.u_circle_store_index_r.datas);
	else 
		return (whyw_ee.Data.u_circle_store_index_w.datas + STORE_DATA_COUNT_CIRCLE - whyw_ee.Data.u_circle_store_index_r.datas);
}

void GetUploadDataMachine_WHYW(u8 data_step, u8* p_send_buf, u16* p_send_len)
{
	switch(upload_frame_stat_whyw)
	{
		case WHYW_STATE_S0:
		{
			if(data_step == UPLOAD_FRAME_REQUEST_NEW)//ݰ
			{
				whyw_online_wait_flag=0;//ߵȴ־
				temp_upload_step = 0;
				upload_frame_retry_times = 0;
				upload_count_flag = 0;
				upload_frame_stat_whyw = WHYW_STATE_S1;
			}
			else if(data_step == UPLOAD_FRAME_UPLOAD_OK)//ͳɹ
			{
				if(upload_count_flag == 0)//¼һϱɹ
				{
					upload_count_flag = 1;
					whyw_ee.Data.ee_upload_count_success.datas++;//ϱɹܴ
				}
				if(temp_upload_step == WHYW_STATE_S10)//ڼ¼ݷͳɹ,
				{
					upload_frame_stat_whyw = WHYW_STATE_S13;//ָ
				}
				else if(temp_upload_step == WHYW_STATE_S20)//ǰݷͳɹ,
				{
					upload_frame_stat_whyw = WHYW_STATE_S5;//ʱ
				}
				upload_frame_retry_times = 0;
				SystemClearUploadAgain();//ش0
			}
			else if(data_step == UPLOAD_FRAME_UPLOAD_RETRY)//·
			{
				if(temp_upload_step == WHYW_STATE_S10)//ڼ¼Ҫط
				{
					upload_frame_stat_whyw = WHYW_STATE_S4;
				}
				else if(temp_upload_step == WHYW_STATE_S20)//ǰҪط
				{
					upload_frame_stat_whyw = WHYW_STATE_S4;
				}
				else
				{
					task_upload_complete_whyw = PTL_PACK_FAIL;//
					upload_frame_stat_whyw = WHYW_STATE_S0;
				}
			}
			else if(data_step == UPLOAD_FRAME_ONLINE_FAIL) //ʧ
			{
				  if(UPLOAD_TYPE_FIX_TIME == GetEventUploadType()||
					(UPLOAD_TYPE_RETRY_AGAIN == GetEventUploadType()))//ʱϴ
				{
					SystemAddUploadAgain();//ش
				}
				whyw_ee.Data.ee_upload_count_fail.datas++;//ʧܴ
				task_upload_complete_whyw = PTL_PACK_FAIL;
				upload_frame_stat_whyw = WHYW_STATE_S0;
			}
			else 
			{
				task_upload_complete_whyw = PTL_PACK_FAIL;
				upload_frame_stat_whyw = WHYW_STATE_S0;
			}
		}
		break;
		case WHYW_STATE_S1://ȡ¼ʱ
		{
			if(TASK_IDLE == EepIfIdle())
			{
				EepRead(EEP_ADDR_WHYW_LAST_RTCC, &upload_circle_rtcc_end.b[0], 7, &s_eep_complete_WHYW);
				upload_frame_stat_whyw = WHYW_STATE_S2;
			}  
		}
		break;
		case WHYW_STATE_S2://ϱ
		{
			if(TASK_IDLE == EepIfIdle())
			{
				upload_data_count = GetUploadDataCount();
				if(upload_data_count > 0)
				{
					upload_packet_count = (upload_data_count/UPLOAD_CIRCLE_MAX_COUNT)+1;//֡
					upload_packet_code = 0;//֡ųʼ
					upload_frame_stat_whyw = WHYW_STATE_S10;
				}
				else//ûм¼,ϱһǰ
				{
					upload_frame_stat_whyw = WHYW_STATE_S20;
				}
			}
		}
		break;
/*>>>>>>>>>>>ݼ¼Ķȡ>>>>>>>>>>>>>>*/
		case WHYW_STATE_S10://ȡһڴ洢
		{
			 if(TASK_IDLE == EepIfIdle())
			 {
				temp_upload_step = WHYW_STATE_S10;
				 
				upload_data_count = GetUploadDataCount();
				 if(upload_data_count >0)//Ҫ
				 {
					if((upload_data_count/UPLOAD_CIRCLE_MAX_COUNT)>0)
					{
						upload_packet_data_count = UPLOAD_CIRCLE_MAX_COUNT;
					}
					else
					{
						upload_packet_data_count = (upload_data_count%UPLOAD_CIRCLE_MAX_COUNT);
					}
					if((whyw_ee.Data.u_circle_store_index_r.datas + upload_packet_data_count) < STORE_DATA_COUNT_CIRCLE)//ûг߽,һ
					{
						uTemp_ee_addr = EEP_ADDR_WHYW_STORE_CIRCLE + whyw_ee.Data.u_circle_store_index_r.datas*4;
						uTemp_read_len =  upload_packet_data_count*STORE_DATA_SIZE_CIRCLE;
						EepRead(uTemp_ee_addr, &upload_circle_buf[0], uTemp_read_len, &s_eep_complete_WHYW);
						upload_frame_stat_whyw = WHYW_STATE_S12;
					}
					else//߽,
					{
						uTemp_ee_addr = EEP_ADDR_WHYW_STORE_CIRCLE + whyw_ee.Data.u_circle_store_index_r.datas*4;
						uTemp_read_len = (whyw_ee.Data.u_circle_store_index_r.datas + upload_packet_data_count - STORE_DATA_COUNT_CIRCLE)*STORE_DATA_SIZE_CIRCLE;
						EepRead(uTemp_ee_addr, &upload_circle_buf[0], uTemp_read_len, &s_eep_complete_WHYW);
						upload_frame_stat_whyw = WHYW_STATE_S11;
					}
				 }
				 else//ûݷ
				 {
						upload_frame_stat_whyw = WHYW_STATE_S5;//ʱ
				 }
			 }
		}
		break;
		
		case WHYW_STATE_S11://ȴȡ1
		{
			 if(TASK_IDLE == EepIfIdle())
			 {
				uTemp_ee_addr = EEP_ADDR_WHYW_STORE_CIRCLE;
				EepRead(uTemp_ee_addr, &upload_circle_buf[uTemp_read_len], (upload_packet_data_count - uTemp_read_len), &s_eep_complete_WHYW);
				upload_frame_stat_whyw = WHYW_STATE_S12;
			 }
		}
		break;
		case WHYW_STATE_S12://ȴȡ2
		{
			 if(TASK_IDLE == EepIfIdle())
			 {
				upload_packet_code++;//֡
				if(ERROR == GetCircleDateTimeStart(&upload_circle_rtcc_start, upload_circle_rtcc_end, (upload_data_count-1), 30))//ʱ
				{
					//ʱʽȷ,ʼдָ,ϱǰ
					whyw_ee.Data.u_circle_store_index_w.datas = 0;
					whyw_ee.Data.u_circle_store_index_r.datas = 0;
					upload_frame_stat_whyw = WHYW_STATE_S20;
				}
				else
				{
					upload_frame_stat_whyw = WHYW_STATE_S3;
				}
			 }
		}
		break;
		case WHYW_STATE_S13://洢ָ,յϱӦ洢
		{
			if(TASK_IDLE == EepIfIdle())
			{
				whyw_ee.Data.u_circle_store_index_r.datas += upload_packet_data_count; 
				whyw_ee.Data.u_circle_store_index_r.datas %= STORE_DATA_COUNT_CIRCLE;//Խ֮ʼλü
				EepWrite(whyw_ee.Data.u_circle_store_index_r.data_buf, EEP_ADDR_WHYW_CIRCLE_INDEX_R, 2, &s_eep_complete_WHYW);
				upload_frame_stat_whyw = WHYW_STATE_S10;//ȡһ
			}  
		}
		break;
/*>>>>>>>>>>>ǰϱ>>>>>>>>>>>>>>*/
		case WHYW_STATE_S20://ϱǰ
		{
			temp_upload_step = WHYW_STATE_S20;
			upload_packet_count = 1;//ϱ֡
			upload_packet_code = 1;//֡
			upload_packet_data_count = 1;//֡¼
			temp_float_data.gp22_u32 =  Gp30CheckDataApp(2);
			temp_CircleData  = (u32)(temp_float_data.gp22_float);
			temp_bcd_CircleData.datas = HexToBcd32(temp_CircleData);
			for(int i=0;i<4;i++)
			{
				upload_circle_buf[i] = temp_bcd_CircleData.data_buf[i];
			}
			RtccGetDateTime(&upload_circle_rtcc_start);//ǰʱΪݲɼʱ䡱
			upload_frame_stat_whyw = WHYW_STATE_S3;
		}
		break;
/*>>>>>>>>>>>ϴ֡>>>>>>>>>>>>>>*/	
		case WHYW_STATE_S3://ϴ֡
		{
			Upload_FrameData();
			Frame_upload_WHYW(p_send_buf,p_send_len);
			task_upload_complete_whyw = PTL_PACK_SUCCESS;
			upload_frame_stat_whyw = WHYW_STATE_S0;
		}
		break;
/*>>>>>>>>>>>ݷʧܺ>>>>>>>>>>>>>>*/	
		case WHYW_STATE_S4://
		{
			if(upload_frame_retry_times < 2) 
			{
				upload_frame_retry_times++;
				upload_frame_stat_whyw = WHYW_STATE_S3;
			} 
			else//·ʧ2εĴ
			{	
				if((UPLOAD_TYPE_FIX_TIME == GetEventUploadType())|| //ʱϴ
					(UPLOAD_TYPE_RETRY_AGAIN == GetEventUploadType()))//ش
				{
					SystemAddUploadAgain();//ش
				}
				whyw_ee.Data.ee_upload_count_fail.datas++;//ʧܴ
				task_upload_complete_whyw = PTL_PACK_FAIL;
				upload_frame_stat_whyw = WHYW_STATE_S0;
			}
		}
		break;
/*>>>>>>>>>>>ʱ>>>>>>>>>>>>>>*/	
		case WHYW_STATE_S5://ʱ
		{
			if(whyw_online_wait_flag == 1)//Ҫߵȴ
			{
				whyw_online_wait_flag = 0;
				if(whyw_ee.Data.ee_nb_online_keep_time>30)
				{
					whyw_ee.Data.ee_nb_online_keep_time = 15;
				}
				Set100msTimer(TIMER_100MS_UPLOAD_MONITOR, 10*whyw_ee.Data.ee_nb_online_keep_time);
				upload_frame_stat_whyw = WHYW_STATE_S6;
			}
			else//ȴ
			{
				task_upload_complete_whyw = PTL_PACK_FAIL;
				upload_frame_stat_whyw = WHYW_STATE_S0;
			}
		}
		break;
		case WHYW_STATE_S6://ȴʱ䵽
		{
			if(whyw_online_wait_flag == 1)//¼ʱ
			{
				whyw_online_wait_flag = 0;
				if(whyw_ee.Data.ee_nb_online_keep_time>30)
				{
					whyw_ee.Data.ee_nb_online_keep_time = 15;
				}
				Set100msTimer(TIMER_100MS_UPLOAD_MONITOR, 10*whyw_ee.Data.ee_nb_online_keep_time);
			}
			else if(whyw_online_wait_flag == 2)//ȴڼյϢ
			{
				whyw_online_wait_flag = 0;
				task_upload_complete_whyw = PTL_PACK_FAIL;
				upload_frame_stat_whyw = WHYW_STATE_S0;
			}
			if(0 == Check100msTimer(TIMER_100MS_UPLOAD_MONITOR))
			{
				task_upload_complete_whyw = PTL_PACK_FAIL;
				upload_frame_stat_whyw = WHYW_STATE_S0;
			}
		}
		break;
		
		default:
		{
			task_upload_complete_whyw = PTL_PACK_FAIL;
			upload_frame_stat_whyw = WHYW_STATE_S0;
		}
		break;
	}
}

u8 NB_SS_Control_GetPara(NB_SS_ControlParaTypeDef paraType)
{
	switch(paraType)
	{
	    case NB_HistroyReadIndex://ʷݵĶָ
		{
			return Sys_data_object.P1.histroy_w;
		}
		case NB_UploadFailTimes://ʧܴ
		{
			u8 temp_fail_times=0;
			temp_fail_times = GetUploadDataCount();
			return temp_fail_times;
		}
		default:
			break;
	}
	return 0;
}

/*************************************************************ݴ洢************/
static void WHYW_Store_InitApp(void)
{
	TYP_STATE_WHYW tmp_init_stat;

	if(Sys_data_object.P3.FirstPowerOnFlag == FIRST_POWER_ON_FLAG)
	{
		tmp_init_stat = WHYW_STATE_S10;
	}
	else
	{
		tmp_init_stat = WHYW_STATE_S20;
	}
    while (tmp_init_stat != WHYW_STATE_S0)
    {
      switch (tmp_init_stat)
      {
        case WHYW_STATE_S0:
        { 
        }
		break;
		//һϵ
        case WHYW_STATE_S10:
        {
            if(TASK_IDLE == EepIfIdle())
            {
				whyw_ee.Data.u_circle_store_index_w.datas = 0;//ݴ洢λ
				whyw_ee.Data.u_circle_store_index_r.datas = 0;//ݶȡλ
				RtccGetDateTime(&whyw_ee.Data.store_circle_rtcc_end);//һ¼ʱ7ֽ
				whyw_ee.Data.ee_nb_online_keep_time = 10;//ʱʱ 1ֽ 10s
				whyw_ee.Data.ee_nb_acq_interval = 30;//ݲɼ¼ʱ 1ֽ ɼ30
				whyw_ee.Data.ee_battery_pra[0]=0x00;//صѹز
				whyw_ee.Data.ee_battery_pra[1]=0x03;
				whyw_ee.Data.ee_battery_pra[2]=0x00;
				whyw_ee.Data.ee_battery_pra[3]=0x03;
				whyw_ee.Data.ee_upload_count_success.datas =0;//ϱɹܴ
				whyw_ee.Data.ee_upload_count_fail.datas = 0;//ϱʧܴ
                EepWrite(&whyw_ee.data_buf[0], EEP_ADDR_WHYW_CIRCLE_INDEX_W, EE_PRA_SIZE_WHYW, &s_eep_complete_WHYW);
                tmp_init_stat = WHYW_STATE_S1;
            }
        }
		break;
		//ǵһϵ
		case WHYW_STATE_S20:
        {
            if (TASK_IDLE == EepIfIdle())
            {
                EepRead(EEP_ADDR_WHYW_CIRCLE_INDEX_W, &whyw_ee.data_buf[0], EE_PRA_SIZE_WHYW, &s_eep_complete_WHYW);
                tmp_init_stat = WHYW_STATE_S21;				
            }		
        }
		break;
		case WHYW_STATE_S21:
        {
            if (TASK_IDLE == EepIfIdle())
            {
				if((u_circle_store_index_w.datas>=STORE_DATA_COUNT_CIRCLE)||(u_circle_store_index_r.datas>=STORE_DATA_COUNT_CIRCLE))
				{
					whyw_ee.Data.u_circle_store_index_w.datas = 0;
					whyw_ee.Data.u_circle_store_index_r.datas = 0;
					RtccGetDateTime(&whyw_ee.Data.store_circle_rtcc_end);
					EepWrite(&whyw_ee.data_buf[0], EEP_ADDR_WHYW_CIRCLE_INDEX_W, EE_PRA_SIZE_WHYW, &s_eep_complete_WHYW);
				}
                tmp_init_stat = WHYW_STATE_S1;
            }
        }
		break;	
		
		case WHYW_STATE_S1:
		{
			if (TASK_IDLE == EepIfIdle())
            {
				tmp_init_stat = WHYW_STATE_S0;	
            }
		}
		break;
		
		default:
		{
			tmp_init_stat  = WHYW_STATE_S0;
		    break;
		}
      }
      EepMachineDriver();
    }
}


//ݴ洢״̬
static void WHYWStore_Machine(void)
{
	switch(step_circle_data_store)
	{
		case WHYW_STATE_S0:
		{
			if (RtccCheckMsgApp(RtccMsg_OtherProtl))
			{
				RtccClearMsgApp(RtccMsg_OtherProtl);
				RtccGetDateTime(&whyw_protl_rtcc_time);
				if((whyw_protl_rtcc_time.s.minute==0x00)||(whyw_protl_rtcc_time.s.minute==0x30))//Сʱ
				{
					FrameSetMsgApp(MsgShenYang_CircleSave);//ݴ洢
				}
			}
			if(FrameCheckMsgApp(MsgShenYang_CircleSave))//ݴ洢Ϣ
			{
				FrameClearMsgApp(MsgShenYang_CircleSave);	
				step_circle_data_store = WHYW_STATE_S1;
			}		
			else if(FrameCheckMsgApp(Msg_ClearHisOther))//
			{
				FrameClearMsgApp(Msg_ClearHisOther);
				step_circle_data_store = WHYW_STATE_S10;
			}
		}
		break;
		case WHYW_STATE_S1://洢
		{
			if(TASK_IDLE == EepIfIdle())
			{
				//ȡǰ
				temp_float_data.gp22_u32 =  Gp30CheckDataApp(2);
				temp_CircleData  = (u32)(temp_float_data.gp22_float);
				temp_bcd_CircleData.datas = HexToBcd32(temp_CircleData);
				if(whyw_ee.Data.u_circle_store_index_w.datas >= STORE_DATA_COUNT_CIRCLE)
				{
					whyw_ee.Data.u_circle_store_index_w.datas = 0;
				}
				uTemp_ee_addr = EEP_ADDR_WHYW_STORE_CIRCLE + whyw_ee.Data.u_circle_store_index_w.datas*STORE_DATA_SIZE_CIRCLE;
				EepWrite(temp_bcd_CircleData.data_buf, uTemp_ee_addr, STORE_DATA_SIZE_CIRCLE, &s_eep_complete_WHYW);
				step_circle_data_store = WHYW_STATE_S2;
			}  
		}
		break;
		case WHYW_STATE_S2: //洢ָ
		{
			if(TASK_IDLE == EepIfIdle())
			{
				whyw_ee.Data.u_circle_store_index_w.datas++;
				if(whyw_ee.Data.u_circle_store_index_w.datas >= STORE_DATA_COUNT_CIRCLE)
				{
					whyw_ee.Data.u_circle_store_index_w.datas = 0;
				}
				EepWrite(whyw_ee.Data.u_circle_store_index_w.data_buf, EEP_ADDR_WHYW_CIRCLE_INDEX_W, 2, &s_eep_complete_WHYW);
				step_circle_data_store = WHYW_STATE_S3;
			}  
		}
		break;
		case WHYW_STATE_S3: //洢ʱ
		{
			if(TASK_IDLE == EepIfIdle())
			{
				RtccGetDateTime(&whyw_ee.Data.store_circle_rtcc_end);
				EepWrite(&whyw_ee.Data.store_circle_rtcc_end.b[0], EEP_ADDR_WHYW_LAST_RTCC, 7, &s_eep_complete_WHYW);
				step_circle_data_store = WHYW_STATE_S4;
			}  
		}
		break;
		case WHYW_STATE_S4: //洢ɹʧܴ
		{
			if(TASK_IDLE == EepIfIdle())
			{
				whyw_ee.Data.ee_upload_count_fail.datas++;//ʧܴ
				EepWrite(&whyw_ee.Data.ee_upload_count_success.data_buf[0], EEP_ADDR_WHYW_UPLOAD_SUCCESS, 4, &s_eep_complete_WHYW);
				step_circle_data_store = WHYW_STATE_S5;
			}  
		}
		break;
		case WHYW_STATE_S5: //ȴ洢
		{
			if(TASK_IDLE == EepIfIdle())
			{
				//RtccAdjustDateTime(1,1800-10);//debug
				step_circle_data_store = WHYW_STATE_S0;
			}  
		}
		break;
		
		 case WHYW_STATE_S10://ݺ,ָʼֵ
        {
            if(TASK_IDLE == EepIfIdle())
            {
				whyw_ee.Data.u_circle_store_index_w.datas = 0;//ݴ洢λ
				whyw_ee.Data.u_circle_store_index_r.datas = 0;//ݶȡλ
				RtccGetDateTime(&whyw_ee.Data.store_circle_rtcc_end);//һ¼ʱ7ֽ
				whyw_ee.Data.ee_nb_online_keep_time = 10;//ʱʱ 1ֽ 10s
				whyw_ee.Data.ee_nb_acq_interval = 30;//ݲɼ¼ʱ 1ֽ ɼ30
				whyw_ee.Data.ee_battery_pra[0]=0x00;//صѹز
				whyw_ee.Data.ee_battery_pra[1]=0x03;
				whyw_ee.Data.ee_battery_pra[2]=0x00;
				whyw_ee.Data.ee_battery_pra[3]=0x03;
				whyw_ee.Data.ee_upload_count_success.datas =0;//ϱɹܴ
				whyw_ee.Data.ee_upload_count_fail.datas = 0;//ϱʧܴ
                EepWrite(&whyw_ee.data_buf[0], EEP_ADDR_WHYW_CIRCLE_INDEX_W, EE_PRA_SIZE_WHYW, &s_eep_complete_WHYW);
                step_circle_data_store = WHYW_STATE_S0;
            }
        }
		break;
		default:
		{
			step_circle_data_store = WHYW_STATE_S0;
			break;
		}
	}
}

//Լݴ洢ֳʼ
void DataStoreInit(void)
{
	Quanzhou_Store_InitApp();
	WHYW_Store_InitApp();
}
//Լݴ洢״̬
void DataStoreMachine(void)
{
	Quanzhou_Store_Machine();//ݴ洢
	WHYWStore_Machine();
}

//Լݴ洢ж
u8 DataStoreIfIdle(void)
{
	if(step_circle_data_store == WHYW_STATE_S0)
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}


#endif





