#include "sys_config.h"
#include "Uwater_frame_app.h"
#include "sys_processor.h"
#include "nb_upload_monitor.h"
#include "UWater_DataTools_App.h"
#include "UWater_ir_app.h"
#include "UWater_eeprom_driver.h"
#include "UWater_power_app.h"
#include "UWater_valve_driver.h"
#include <string.h>

#if UPLOAD_MODE_1
static u8 s_eep_complete_up_monitor=0; //ee洢־
static u8 up_monitor_para_buf[UP_PARA_NUM];//ϱ
static ENUM_APP_LIFE_CNT nb_life_time_state=APP_LIFE_CNT_S0;//NB״̬
static ENUM_APP_LIFE_CNT ir_life_time_state=APP_LIFE_CNT_S0;//״̬
static u32 nb_life_time_start_time=0;//NBʼʱ
static u32 ir_life_time_start_time=0;//⼤ʼʱ
static u32 total_wake_time = 0;//⻽ʱ
static u16 life_time_cnt = 0;//
static u8 life_time_minute_cnt = 0;//
static u16 tmp_life_time = 0;//ʱʱ
//ʣֵ
static float remain_percent_use_life;
static float remain_percent_use_energy;
static float remain_para_energy_life;
//ϱƫʱ
static u8 up_delay_para_cnt=0;
static ENUM_APP_LIFE_CNT valve_life_time_state=APP_LIFE_CNT_S0;//ص״̬
#if defined(VALVE)
static u32 valve_life_time_start_time=0;//ؿʼʱ
#endif


//ϱƲ
void setUploadControlPara(ENUM_UPLOAD_CONTROL paraId, u8 paraData)
{
	if(paraId<UP_PARA_NUM)
	{
		up_monitor_para_buf[paraId] = paraData;
	}
}
//ȡϱƲ
u8 getUploadControlPara(ENUM_UPLOAD_CONTROL paraId)
{
	if(paraId<UP_PARA_NUM)
	{
		return up_monitor_para_buf[paraId];
	}
	return 0;
}

//NBʱ估ͳ
void AppLifeTimeCountMachine(void)
{
	if(RtccCheckMsg()&0x10)//ж,NB⻽ѵʱ
	{
		RtccClearMsg(4); 
		life_time_cnt++; 
		life_time_cnt %= HOUR_TO_SECOND;
	}
	if(RtccCheckMsg()&0x20)//ж,ļ
	{
		RtccClearMsg(5);
		life_time_minute_cnt++;
		if(life_time_minute_cnt>=60)
		{
			life_time_minute_cnt=0;
			Sys_data_object.P1.run_information_object.total_use_sum_times_sec.to_uint32 += HOUR_TO_SECOND;//ۼʹʱ
			Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= ONE_HOUR_STATIC_ENERGY;
		}
	}
	//NBļ
	switch(nb_life_time_state)
	{
		case(APP_LIFE_CNT_S0):
		{
			if(TASK_BUSY == FixedTimeNbIoTUploadIfIdle())
			{
				nb_life_time_start_time = life_time_cnt;
				nb_life_time_state = APP_LIFE_CNT_S1;
			}
		}
		break;
		
		case(APP_LIFE_CNT_S1):
		{
			if(TASK_IDLE == FixedTimeNbIoTUploadIfIdle())
			{
				s16 s_temp_snr=0;
				s16 s_temp_rsrp=0;
				if(life_time_cnt >= nb_life_time_start_time)
				{
					tmp_life_time = life_time_cnt - nb_life_time_start_time;
				}
				else
				{
					tmp_life_time = HOUR_TO_SECOND + life_time_cnt - nb_life_time_start_time;
				}
				//յЧָ,ʱ
				if(getUploadControlPara(UP_BOOT_MSG) == UPDATE_MODE_DIFF)
				{
					tmp_life_time += 600;//10
				}
				else if(getUploadControlPara(UP_BOOT_MSG) == UPDATE_MODE_NORMAL)
				{
					tmp_life_time += 1800;//30
				}
				setUploadControlPara(UP_BOOT_MSG,0);
				
				//¼NBʱNBԾ
				Sys_data_object.P1.run_information_object.nb_use_sum_times_sec.to_uint32 += tmp_life_time;
				Sys_data_object.P1.run_information_object.nb_upload_happen_num++; 
				
				//ݱźֵԼʱȥӦĵ	
				NbiotGetSNR(&s_temp_snr);
				NbiotGetRSRP(&s_temp_rsrp);
				s_temp_snr /=10;
				s_temp_rsrp /=10;
				
				if(getUploadControlPara(UP_CGATT_FAIL)==TRUE)//ηʧ
				{
					Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= NB_UPLOAD_RSRP_FAIL_ONE_SECOND_ENERGY*tmp_life_time;
					//ϱƫʱ޸
					if(GetEventUploadType()==UPLOAD_TYPE_FIX_TIME)//ʱϱ
					{
						up_delay_para_cnt++;
						up_delay_para_cnt = (up_delay_para_cnt%7);
						setUploadControlPara(UP_DELAY_COUNT,up_delay_para_cnt);
						setUploadControlPara(UP_AT_ALL_MSG,TRUE); //ϱʧ,´ϱʹȫָϱϢ
					}
				}
				else if(s_temp_snr < 0)//ֵ,źźܲ
				{
					Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= NB_UPLOAD_RSRP_WEAK_ONE_SECOND_ENERGY*tmp_life_time;
				}
				else if(s_temp_rsrp < -120)//120
				{
					Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= NB_UPLOAD_RSRP_WEAK_ONE_SECOND_ENERGY*tmp_life_time;
				}
				else if(s_temp_rsrp < -115)//115~120
				{
					Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= NB_UPLOAD_RSRP_120_ONE_SECOND_ENERGY*tmp_life_time;
				}
				else if(s_temp_rsrp < -105)//105~115
				{
					Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= NB_UPLOAD_RSRP_115_ONE_SECOND_ENERGY*tmp_life_time;
				}
				else if(s_temp_rsrp < -90)//90~105
				{
					Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= NB_UPLOAD_RSRP_105_ONE_SECOND_ENERGY*tmp_life_time;
				}
				else//> -90
				{
					Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= NB_UPLOAD_RSRP_90_ONE_SECOND_ENERGY*tmp_life_time;
				}			
				nb_life_time_state = APP_LIFE_CNT_S2;
			}
		}
		break;
		case APP_LIFE_CNT_S2://EE洢
		{
			if (TASK_IDLE == EepIfIdle())
			{
				EepWrite(&(Sys_data_object.P1.run_information_object.total_use_sum_times_sec.to_uint8[0]), EEP_FRMAE_BATTERY_ENERGY, sizeof(Sys_data_object.P1.run_information_object), &s_eep_complete_up_monitor);
				nb_life_time_state = APP_LIFE_CNT_S0;
			}
		}
		break;
		default:
			nb_life_time_state = APP_LIFE_CNT_S0;
		break;
	}
	//⹦ļ
	switch(ir_life_time_state)
	{
		case(APP_LIFE_CNT_S0):
		{
			if(FALSE == IrIfSleepApp())
			{
				ir_life_time_start_time = life_time_cnt;
				ir_life_time_state = APP_LIFE_CNT_S1;
			}
		}
		break;
		
		case(APP_LIFE_CNT_S1):
		{
			if(TRUE == IrIfSleepApp())
			{
				if(life_time_cnt >= ir_life_time_start_time)
				{
					tmp_life_time = life_time_cnt - ir_life_time_start_time;
				}
				else
				{
					tmp_life_time = HOUR_TO_SECOND + life_time_cnt - ir_life_time_start_time;
				}
				total_wake_time += tmp_life_time;
				if(total_wake_time > MINITE_TO_SECOND)  //ʱ 
				{
					total_wake_time -= MINITE_TO_SECOND;
					Sys_data_object.P1.run_information_object.use_sum_times_sec.to_uint32 += 60;//ۼƷʱ1
					Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= ONE_MIN_WAKE_ENERGY; //1ӵĻѹ
				}		
				ir_life_time_state = APP_LIFE_CNT_S0;
			}
		}
		break;	
		default:
		{
			ir_life_time_state = APP_LIFE_CNT_S0;
		}
		break;
	}
	#if defined(VALVE)
//عļ
	switch(valve_life_time_state)
	{
		case(APP_LIFE_CNT_S0):
		{
			if(FALSE == ValveIfIdle())
			{
				valve_life_time_start_time = life_time_cnt;
				valve_life_time_state = APP_LIFE_CNT_S1;
			}
		}
		break;
		
		case(APP_LIFE_CNT_S1):
		{
			if(TRUE == ValveIfIdle())
			{
				if(life_time_cnt >= valve_life_time_start_time)
				{
					tmp_life_time = life_time_cnt - valve_life_time_start_time;
				}
				else
				{
					tmp_life_time = HOUR_TO_SECOND + life_time_cnt - valve_life_time_start_time;
				}
				Sys_data_object.P1.run_information_object.valve_use_sum_times_sec += tmp_life_time;//ۼƹʱ
				Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= VAVLE_WORK_ENERGY*tmp_life_time; //ٷŻĹ
				valve_life_time_state = APP_LIFE_CNT_S0;
			}
		}
		break;	
		default:
		{
			valve_life_time_state = APP_LIFE_CNT_S0;
		}
		break;
	}
	#endif
}

//NBϱƲ
void NbUploadParaSet(void)
{
	char imei_buf[16];
	DateTime temp_rtcc_time;
	RtccGetDateTime(&temp_rtcc_time);
	//ʣʹռ
	if(HOURS_OF_7YEARS > Sys_data_object.ee_data.data.work_hour)
	{
		//remain_percent_use_life = (float)(HOURS_OF_7YEARS-Sys_data_object.ee_data.data.work_hour)/(float)HOURS_OF_7YEARS;
		remain_percent_use_life = (float)(HOURS_OF_7YEARS-Sys_data_object.P1.run_information_object.total_use_sum_times_sec.to_uint32/HOUR_TO_SECOND)/(float)HOURS_OF_7YEARS;
	}
	else
	{
		remain_percent_use_life = 0;
	}
	//ʣռ
	remain_percent_use_energy = (float)Sys_data_object.P1.run_information_object.bat_surplus.to_uint32/(float)ENERGY_OF_26500;
	setUploadControlPara(UP_BAT_STATE, remain_percent_use_energy*15);//״̬ʾ
	
	//ʣʣʹʱֵ
	if(PowerCheckStatusSys() == LOW_POWER)//Ƿѹ
	{
		remain_para_energy_life = 0.1;
	}
	else
	{
		if(remain_percent_use_life == 0)//Ѿ7
		{
			remain_para_energy_life = 1;
		}
		else
		{
			if(Sys_data_object.P1.run_information_object.bat_surplus.to_uint32>(remain_percent_use_life*ENERGY_OF_IDLE))//Ԥ
			{
				remain_para_energy_life = (float)(remain_percent_use_energy/remain_percent_use_life)*NB_BAT_PARA;
			}
			else//޷
			{
				remain_para_energy_life = 0.1;
			}
		}
	}
	
	//ֵлж
	if((Sys_data_object.P1.run_information_object.ee_remain_para_energy_life>0)&&(Sys_data_object.P1.run_information_object.ee_remain_para_energy_life<=1.5))
	{
		if(remain_para_energy_life < Sys_data_object.P1.run_information_object.ee_remain_para_energy_life)
		{
			Sys_data_object.P1.run_information_object.ee_remain_para_energy_life = remain_para_energy_life;
		}
	}
	else
	{
		Sys_data_object.P1.run_information_object.ee_remain_para_energy_life = remain_para_energy_life;
	}
	//ݵʣʱֵϱƵ
	if(Sys_data_object.P1.run_information_object.ee_remain_para_energy_life>1.5)
	{
		setUploadControlPara(UP_RETRY_NUM, Sys_data_object.P1.report_retry_times);//1
		setUploadControlPara(UP_DELAY_TIME1, NB_WAIT_TIME_5S);//ָʱ3s
		setUploadControlPara(UP_DAY_COUNT,(Sys_data_object.P1.func_cfg_bytes[13]>>4)&0x0F);//ϱ1
	}
	else if(Sys_data_object.P1.run_information_object.ee_remain_para_energy_life>1)
	{
		setUploadControlPara(UP_RETRY_NUM,0);//0
		setUploadControlPara(UP_DELAY_TIME1, NB_WAIT_TIME_5S);
		setUploadControlPara(UP_DAY_COUNT,Sys_data_object.P1.func_cfg_bytes[13]&0x0F);//ϱ1
	}
	else if(Sys_data_object.P1.run_information_object.ee_remain_para_energy_life>0.8)
	{
		setUploadControlPara(UP_RETRY_NUM,0);//0
		setUploadControlPara(UP_DELAY_TIME1, NB_WAIT_TIME_5S);
		setUploadControlPara(UP_DAY_COUNT,(Sys_data_object.P1.func_cfg_bytes[14]>>4)&0x0F);//ϱ2
	}
	else if(Sys_data_object.P1.run_information_object.ee_remain_para_energy_life>0.5)
	{
		setUploadControlPara(UP_RETRY_NUM,0);//0
		setUploadControlPara(UP_DELAY_TIME1,NB_WAIT_TIME_5S);
		setUploadControlPara(UP_DAY_COUNT,Sys_data_object.P1.func_cfg_bytes[14]&0x0F);//ϱ3
	}
	else
	{
		setUploadControlPara(UP_RETRY_NUM,0);//0
		setUploadControlPara(UP_DELAY_TIME1,NB_WAIT_TIME_5S);
		setUploadControlPara(UP_DAY_COUNT,(Sys_data_object.P1.func_cfg_bytes[15]>>4)&0x0F);//ϱ7
		setUploadControlPara(UP_WITH_UDP,TRUE);//UDPϱ
	}
	Sys_data_object.P1.report_retry_times = getUploadControlPara(UP_RETRY_NUM);//Դ
	//ϱǷ񾫼
	NbiotGetIMEI(imei_buf); 
	if(strlen(imei_buf)<15)//жIMEI
	{
		setUploadControlPara(UP_AT_SIMPLE, AT_SIMPLE_NULL);//ATָ
		setUploadControlPara(UP_DELAY_TIME1,NB_WAIT_TIME_5S);
		setUploadControlPara(UP_WITH_UDP,TRUE);//UDPϱ
	}
	else
	{
		if((GetEventUploadType()==UPLOAD_TYPE_HAND_KEY)||
			(GetEventUploadType()==UPLOAD_TYPE_FRAME_ORDER)||
			(GetEventUploadType()==UPLOAD_TYPE_SET_IP)||
			(getUploadControlPara(UP_AT_ALL_MSG)==TRUE))
		{
			setUploadControlPara(UP_AT_ALL_MSG,FALSE);//ʹȫָϱϢ
			setUploadControlPara(UP_AT_SIMPLE, AT_SIMPLE_NULL);//ATָ
			setUploadControlPara(UP_DELAY_TIME1,NB_WAIT_TIME_5S);
			setUploadControlPara(UP_WITH_UDP,TRUE);//UDPϱ
		} 
		else
		{
			if((GetEventUploadType()==UPLOAD_TYPE_FIX_TIME)||(GetEventUploadType()==UPLOAD_TYPE_RETRY_AGAIN))//ʱ\شϱ
			{
				setUploadControlPara(UP_AT_SIMPLE, AT_SIMPLE_M1);//AT1
				setUploadControlPara(UP_DELAY_TIME1, NB_WAIT_TIME_5S);
				if((BCD2HEX(temp_rtcc_time.s.day)%3)==0)
				{
					setUploadControlPara(UP_WITH_UDP, TRUE);//UDPϱ
				}
				else
				{
					setUploadControlPara(UP_WITH_UDP,FALSE);//رUDPϱ
				}
			}
			else if(GetEventUploadType()==UPLOAD_TYPE_VALVE_CLOSE)//طƵϱ
			{
				setUploadControlPara(UP_AT_SIMPLE, AT_SIMPLE_M2);//AT2
				setUploadControlPara(UP_DELAY_TIME1, NB_WAIT_TIME_5S);
				setUploadControlPara(UP_WITH_UDP,FALSE);//رUDPϱ

			}
		}
	}
}

//ڼ¼Ƿ
u8 AppLifeTimeCountMachineIfIdle(void)
{
	if((APP_LIFE_CNT_S0 == nb_life_time_state)&&(APP_LIFE_CNT_S0 == ir_life_time_state)&&(APP_LIFE_CNT_S0 == valve_life_time_state))
	{
		return TASK_IDLE;
	}
	else
	{
		return TASK_BUSY;
	}	
}
#elif UPLOAD_MODE_2
static u8 up_monitor_para_buf[UP_PARA_NUM];//ϱ
static ENUM_APP_LIFE_CNT ble_life_time_state=APP_LIFE_CNT_S0;//״̬
static ENUM_APP_LIFE_CNT ir_life_time_state=APP_LIFE_CNT_S0;//״̬
static u32 ble_life_time_start_time=0;//ʼʱ
static u32 ble_total_wake_time = 0;//ʱ
static u32 ir_life_time_start_time=0;//⼤ʼʱ
static u32 ir_total_wake_time = 0;//⻽ʱ
static u16 life_time_cnt = 0;//
static u8 life_time_minute_cnt = 0;//
static u16 tmp_life_time = 0;//ʱʱ

static ENUM_APP_LIFE_CNT valve_life_time_state=APP_LIFE_CNT_S0;//ص״̬
#if defined(VALVE)
static u32 valve_life_time_start_time=0;//ؿʼʱ
#endif

//ϱƲ
void setUploadControlPara(ENUM_UPLOAD_CONTROL paraId, u8 paraData)
{
	if(paraId<UP_PARA_NUM)
	{
		up_monitor_para_buf[paraId] = paraData;
	}
}
//ȡϱƲ
u8 getUploadControlPara(ENUM_UPLOAD_CONTROL paraId)
{
	if(paraId<UP_PARA_NUM)
	{
		return up_monitor_para_buf[paraId];
	}
	return 0;
}

//ͳ
void AppLifeTimeCountMachine(void)
{
	if(RtccCheckMsg()&0x10)//ж,⻽ѵʱ
	{
		RtccClearMsg(4); 
		life_time_cnt++; 
		life_time_cnt %= HOUR_TO_SECOND;
	}
	if(RtccCheckMsg()&0x20)//ж,ļ
	{
		RtccClearMsg(5);
		life_time_minute_cnt++;
		if(life_time_minute_cnt>=60)
		{
			life_time_minute_cnt=0;
			Sys_data_object.P1.run_information_object.total_use_sum_times_sec.to_uint32 += HOUR_TO_SECOND;//ۼʹʱ
			Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= ONE_HOUR_STATIC_ENERGY;
		}
	}
	//ļ
	switch(ble_life_time_state)
	{
		case(APP_LIFE_CNT_S0):
		{
			if((BleConnectIfIdle() == TASK_BUSY)||(BleIfSleep()==TASK_BUSY))
			{
				ble_life_time_start_time = life_time_cnt;
				ble_life_time_state = APP_LIFE_CNT_S1;
			}
		}
		break;
		
		case(APP_LIFE_CNT_S1):
		{
			if((BleConnectIfIdle() == TASK_IDLE)&&(BleIfSleep()==TASK_IDLE))
			{
				if(life_time_cnt >= ble_life_time_start_time)
				{
					tmp_life_time = life_time_cnt - ble_life_time_start_time;
				}
				else
				{
					tmp_life_time = HOUR_TO_SECOND + life_time_cnt - ble_life_time_start_time;
				}
				ble_total_wake_time += tmp_life_time;
				if(ble_total_wake_time > MINITE_TO_SECOND)  //ʱ 
				{
					ble_total_wake_time -= MINITE_TO_SECOND;
									//¼NBʱNBԾ
					Sys_data_object.P1.run_information_object.nb_use_sum_times_sec.to_uint32 += 60;//ۼƷʱ1
					Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= BLE_ONE_MIN_ENERGY; //1ӵ
				}	
				Sys_data_object.P1.run_information_object.nb_upload_happen_num++;				
				ble_life_time_state = APP_LIFE_CNT_S0;
			}
		}
		break;
		
		default:
		{
			ble_life_time_state = APP_LIFE_CNT_S0;
		}
		break;
	}
	//⹦ļ
	switch(ir_life_time_state)
	{
		case(APP_LIFE_CNT_S0):
		{
			if(FALSE == IrIfSleepApp())
			{
				ir_life_time_start_time = life_time_cnt;
				ir_life_time_state = APP_LIFE_CNT_S1;
			}
		}
		break;
		
		case(APP_LIFE_CNT_S1):
		{
			if(TRUE == IrIfSleepApp())
			{
				if(life_time_cnt >= ir_life_time_start_time)
				{
					tmp_life_time = life_time_cnt - ir_life_time_start_time;
				}
				else
				{
					tmp_life_time = HOUR_TO_SECOND + life_time_cnt - ir_life_time_start_time;
				}
				ir_total_wake_time += tmp_life_time;
				if(ir_total_wake_time > MINITE_TO_SECOND)  //ʱ 
				{
					ir_total_wake_time -= MINITE_TO_SECOND;
					Sys_data_object.P1.run_information_object.use_sum_times_sec.to_uint32 += 60;//ۼƷʱ1
					Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= ONE_MIN_WAKE_ENERGY; //1ӵĻѹ
				}		
				ir_life_time_state = APP_LIFE_CNT_S0;
			}
		}
		break;	
		default:
		{
			ir_life_time_state = APP_LIFE_CNT_S0;
		}
		break;
	}
	#if defined(VALVE)
//عļ
	switch(valve_life_time_state)
	{
		case(APP_LIFE_CNT_S0):
		{
			if(FALSE == ValveIfIdle())
			{
				valve_life_time_start_time = life_time_cnt;
				valve_life_time_state = APP_LIFE_CNT_S1;
			}
		}
		break;
		
		case(APP_LIFE_CNT_S1):
		{
			if(TRUE == ValveIfIdle())
			{
				if(life_time_cnt >= valve_life_time_start_time)
				{
					tmp_life_time = life_time_cnt - valve_life_time_start_time;
				}
				else
				{
					tmp_life_time = HOUR_TO_SECOND + life_time_cnt - valve_life_time_start_time;
				}
				Sys_data_object.P1.run_information_object.valve_use_sum_times_sec += tmp_life_time;//ۼƹʱ
				Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 -= VAVLE_WORK_ENERGY*tmp_life_time; //ٷŻĹ
				valve_life_time_state = APP_LIFE_CNT_S0;
			}
		}
		break;	
		default:
		{
			valve_life_time_state = APP_LIFE_CNT_S0;
		}
		break;
	}
	#endif
}

//ڼ¼Ƿ
u8 AppLifeTimeCountMachineIfIdle(void)
{
	if((APP_LIFE_CNT_S0 == ble_life_time_state)&&(APP_LIFE_CNT_S0 == ir_life_time_state)&&(APP_LIFE_CNT_S0 == valve_life_time_state))
	{
		return TASK_IDLE;
	}
	else
	{
		return TASK_BUSY;
	}	
}

#endif




