/************************************************************************************
 * @Copyright (c)    :(C)2017, Qindao ieslab Co., Ltd
 * @FileName   	     :pic24_nb_driver.c
 * @Author           :QDIES PLATFORM TEAM
 * @Version          :V1.0
 * @Date             :2017-03-01
 * @Description     :
 ************************************************************************************/
#include "sys_config.h"
#ifdef NB_MODULE_BC25
#ifdef	__cplusplus
extern "C"
{
#endif

#include "nb_uart_driver_bc25.h"
#include "nb_driver_bc25.h"
#include "stdio.h"
#include <time.h>
#include "UWater_timer1uS_driver.h"
#include "UWater_uart_driver.h"
#include "UWater_Rtcc_Driver.h"
#include "UWater_frame_app.h"
#include "UWater_Adc_driver.h"
#include "nb_upload_monitor.h"
/********************************************************************/
NBIOT_PARA Nbiot_Para;
NBIOT_MSG Nbiot_Msg;
static NBIOT_SEND_DATA Nbiot_Send_Data;
//static u8 *g_s_csq_value;

//״̬(״̬е״̬)
u8 g_s_nbiot_main_state = NBIOT_S_IDLE;
//u8 s_send_state;

//־λ
u8 g_s_nbiot_task_flag = TASK_INIT;
u8 g_s_nbiot_mode_flag = NO_NBIOT_TASK;
u8 g_s_nbiot_send_type;
u8 g_s_nbiot_read_ccid_flag = FALSE;
u8 g_s_nbiot_read_ECL_flag = FALSE;
u8 flag_clear_ncsearfcn = 0;
u8 nb_power_flag = FALSE;
u8 s_init_state = S_INIT_POWER_ON;
u8 s_coap_connect_state = S_COAP_CONNECT_START;
u8 s_udp_connect_state = S_UDP_CONNECT_START;
u8 s_coap_send_state = S_SEND_START;
u8 s_udp_send_state = S_SEND_START;
u8 s_power_off_state = S_START;
char c_AT_NMGS[40 + UP_BUF_SIZE*2];//ݳȽС

static const char* c_AT_NUESTATS = "AT+QENG=0\r";
static const char* c_AT_CCLK = "AT+CCLK?\r"; //ѯվʱ
//ipַͶ˿ָ
unsigned char *coap_ip;
u16 coap_port;
unsigned char *udp_ip1;
u16 udp_port1;
unsigned char *udp_ip2;
u16 udp_port2;
u8 nbiot_temp_connect_type=NBIOT_CONNECT_COAP;
//PSM״̬
TYP_PSM_STATE psm_model_state = PSM_STATE_OUT;
TYP_PSM_WAKEUP_STATE s_psm_wakeup_state = PSM_WKUPSTA_IDLE;
TYP_PSM_SLEEP_STATE s_psm_sleep_state = PSM_SLPSTA_IDLE;
//PSM쳣
static u8 s_psm_adc_done = 0; // ADװɱ־
static u32 s_psm_adc_result = 0; // ADת
/*****************************ڲ״̬***********************************/
void NbiotInitMachine(void);
void CoapConnectMachine(void);
void UdpConnectMachine(void);
void CoapSendDataMachine(void);
void UdpSendDataMachine(void);
void NbiotPowerOffMachine(void);
void UdpReadDataMachine(void);
//static void NbiotMsgDeal(void);
void NbiotReadECLSNRMachine(void);
void StartUdpSendData(void);
void sys_get_three_code (void);
void OnenetConnectMachine(void);
void OneNetSendDataMachine(void);
void StartOnenetAckRev(void);
void NbiotRevAckMachine(void);
/*****************************ڲʱӿ**********************************/
void set_timer_1s(u16 time);
u16 check_timer_1s(void);
void set_timer_1ms(u16 time);
u16 check_timer_1ms(void);
void CoapStartConnect(void);
void StartCoapSendData(void);

void StartNbiotInit(void);
void UdpStartConnect(u8 udp_num);

void OneNetStartConnect(void);
void StartOnenetSendData(void);

void Psm_Wakup_Machine(void);
void Psm_Sleep_Machine(void);
/*****************************ⲿӿ****************************************/
void NB_Power_Disable(void) 
{
	Gpio_WriteOutputIO(BAT_NB_PORT, BAT_NB_PIN, FALSE);
	nb_power_flag = FALSE;
}

void NB_Power_Enable(void)  
{
	Gpio_WriteOutputIO(BAT_NB_PORT, BAT_NB_PIN, TRUE);
	nb_power_flag = TRUE;
}

u8 If_NB_Poweron(void)
{    
	return nb_power_flag;    
}
/***************************************************************************
* @fun_name     void NbModuleIOInit(void)
* @brief        ģ鹩IOģ鸴λԴPSMųʼ
***************************************************************************/
void NbModuleIOInit(void)
{
    stc_gpio_cfg_t stcGpioCfg;
    DDL_ZERO_STRUCT(stcGpioCfg);
    stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ
    stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->
    stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
    stcGpioCfg.enPd = GpioPdDisable;
    stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©
    stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB
    Gpio_Init(BAT_NB_PORT, BAT_NB_PIN, &stcGpioCfg);  //ģ鹩IO
    Gpio_Init(RSTN_NB_PORT, RSTN_NB_PIN, &stcGpioCfg);
    Gpio_Init(NB_PSM_WAKE_PORT, NB_PSM_WAKE_PIN, &stcGpioCfg);
    Gpio_Init(PWR_NB_PORT, PWR_NB_PIN, &stcGpioCfg);   //Դƽ
    Gpio_WriteOutputIO(BAT_NB_PORT, BAT_NB_PIN, FALSE);
    Gpio_WriteOutputIO(PWR_NB_PORT, PWR_NB_PIN, FALSE);
	Gpio_WriteOutputIO(RSTN_NB_PORT, RSTN_NB_PIN, FALSE); 
	Gpio_WriteOutputIO(NB_PSM_WAKE_PORT , NB_PSM_WAKE_PIN, FALSE);
}
/***************************************************************************
 * @fun_name     void NbiotMainMachine()
 * @brief        NBIOTռѭУNBIOT
 ***************************************************************************/
void NbiotMainMachine(void)
{
    switch (g_s_nbiot_main_state)
    {
        case NBIOT_S_IDLE:
		{
			//Լ޸ģudp·ָӦ̫̣֡Ҫѯ
			/*if(TRUE == UdpIfNeedReadDataBc25(NBIOT_CONNECT_UDP1))
			{
				ClearUdpReadDataFlag(NBIOT_CONNECT_UDP1);
				SetRcvDataType(NB_RCV_UDP1_DATA);
				g_s_nbiot_main_state = NBIOT_READ_UDP_DATA;
			}
			else if(TRUE == UdpIfNeedReadDataBc25(NBIOT_CONNECT_UDP2))
			{
				ClearUdpReadDataFlag(NBIOT_CONNECT_UDP2);
				SetRcvDataType(NB_RCV_UDP2_DATA);
				g_s_nbiot_main_state = NBIOT_READ_UDP_DATA;
			}
			else if(TRUE  == Check_Udp_Data_Received())
			{
				Clear_Udp_Rec_Data_Flag();
				g_s_nbiot_main_state = NBIOT_READ_UDP_DATA;
			}
			else*/
			if(TRUE == NbiotGetRevAck())//յONNET·,ȽӦӦһ
			{
				ClearNbiotGetRevAck();
				StartOnenetAckRev();
				g_s_nbiot_main_state = NBIOT_REV_ACK;
			}
			else if(FrameCheckMsgApp(Msg_PsmPowerCheck))
			{
				FrameClearMsgApp(Msg_PsmPowerCheck);
				if(psm_model_state == PSM_STATE_SLEEP)
				{
					NbiotPsmCheckTask();
				}
			}
		}
        break;

        case NBIOT_POWER_INIT:
        {
            if (TASK_INIT == g_s_nbiot_task_flag) //ǳʼ״̬
            {
                NbiotInitMachine(); //ģʼ״̬
            }
            else if (TASK_SUCCESS == g_s_nbiot_task_flag) //ɹ
            {
				u8 temp_iccid_buf[20];
                NbiotGetICCID((char*)temp_iccid_buf); //йƶΪ:898600;898602;898604;898607;898608 й898603;898611
				Nbiot_Para.Telecom = SIM_CARD_TELECOM;//ſ
				if(temp_iccid_buf[4]=='0')
				{
				    if((temp_iccid_buf[5]=='0')||(temp_iccid_buf[5]=='2')||(temp_iccid_buf[5]=='4')||(temp_iccid_buf[5]=='7')||(temp_iccid_buf[5]=='8'))
					{
					    Nbiot_Para.Telecom = SIM_CARD_MOBILE;
					}
				}
                Nbiot_Para.net_state = NB_ON_LINE;
				g_s_nbiot_task_flag = TASK_INIT;
				g_s_nbiot_main_state = NBIOT_S_IDLE;
            }
            else //ʧ
            {
				*Nbiot_Send_Data.state = NBIOT_ERROR;
                g_s_nbiot_task_flag = TASK_INIT; 
                g_s_nbiot_main_state = NBIOT_S_IDLE; 
            }
        }
        break;

		case NBIOT_NET_OPEN:
		{
			if (TASK_INIT == g_s_nbiot_task_flag)
            {
				if(nbiot_temp_connect_type == NBIOT_CONNECT_UDP1)
				{
					UdpConnectMachine();
				}
				else if(nbiot_temp_connect_type == NBIOT_CONNECT_UDP2)
				{
					UdpConnectMachine();
				}
				else
				{
					if(Nbiot_Para.Telecom == SIM_CARD_MOBILE)//ƶ
					{
						OnenetConnectMachine();//ONNETƽ̨״̬
					}
					else//ſ
					{
						CoapConnectMachine(); //վ״̬	
					}
				}
            }
            else if (TASK_SUCCESS == g_s_nbiot_task_flag)
            {
				if((Sys_data_object.P1.func_cfg_bytes[12]&0x80)&&(Sys_data_object.P1.func_cfg_bytes[12]&0x03)) //PSMģʽϱж
				{
					psm_model_state = PSM_STATE_WAKE; 
				}
				else
				{
					psm_model_state = PSM_STATE_OUT; 
				}
				if(nbiot_temp_connect_type == NBIOT_CONNECT_COAP)
				{
					 Nbiot_Para.coap_state = CONNECT_ON_LINE;	
				}
				else if(nbiot_temp_connect_type == NBIOT_CONNECT_UDP1)
				{
					 Nbiot_Para.udp1_state = CONNECT_ON_LINE;
				}
				else if(nbiot_temp_connect_type == NBIOT_CONNECT_UDP2)
				{
					 Nbiot_Para.udp2_state = CONNECT_ON_LINE;
				}
				g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE;
            }
            else
            {
                g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE; 
            }
		}
		break;

		case NBIOT_DATA_SEND:
        {
			if (g_s_nbiot_task_flag == TASK_INIT)
			{
				if(g_s_nbiot_send_type == SEND_TYPE_COAP)
				{
					if(Nbiot_Para.Telecom == SIM_CARD_MOBILE)//ƶ
					{
						OneNetSendDataMachine();
					}
					else//ſ
					{
						CoapSendDataMachine(); //ݷ״̬
					}
				}
				else if(g_s_nbiot_send_type == SEND_TYPE_UDP1)
				{
					UdpSendDataMachine(); //ݷ״̬
				}
				else if(g_s_nbiot_send_type == SEND_TYPE_UDP2)
				{
					UdpSendDataMachine(); //ݷ״̬
				}
				else
				{
					g_s_nbiot_task_flag = TASK_INIT;
					g_s_nbiot_main_state = NBIOT_S_IDLE; 
				}
			}
			else//ϻص״̬
			{
				g_s_nbiot_task_flag = TASK_INIT;
				g_s_nbiot_main_state = NBIOT_S_IDLE; 
			}
        }
        break;

        case NBIOT_POWER_OFF:
        {
            if (TASK_INIT == g_s_nbiot_task_flag)
            {
                NbiotPowerOffMachine(); //ϵػ
            }
            else
            {
				g_s_nbiot_mode_flag = NO_NBIOT_TASK;
                g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE;
                Nbiot_Para.net_state = NB_OFF_LINE;
				Nbiot_Para.coap_state = CONNECT_OFF_LINE;
				Nbiot_Para.udp1_state = CONNECT_OFF_LINE;
				Nbiot_Para.udp2_state = CONNECT_OFF_LINE;
            }
        }
        break;

        case NBIOT_READ_ECL_SNR:
        {
            if (NB_ON_LINE == Nbiot_Para.net_state)
            {
                if (g_s_nbiot_task_flag == TASK_INIT)
                {
                    NbiotReadECLSNRMachine(); //CSQ״̬йԼҪԼ죬һǶźֵɵ״̬
                }
                else if (g_s_nbiot_task_flag == TASK_SUCCESS)
                {
                    *Nbiot_Send_Data.state = RSRP_SUCCESS;
                    g_s_nbiot_mode_flag = NO_NBIOT_TASK;
                    g_s_nbiot_task_flag = TASK_INIT;
                    g_s_nbiot_main_state = NBIOT_S_IDLE;
                }
                else
                {
                    g_s_nbiot_mode_flag = NO_NBIOT_TASK;
                    g_s_nbiot_task_flag = TASK_INIT;
                    g_s_nbiot_main_state = NBIOT_S_IDLE;
                }
            }
            else //
            {
                if (TRUE == g_s_nbiot_read_ECL_flag)
                {
                    if (g_s_nbiot_task_flag == TASK_INIT)
                    {
                        NbiotReadECLSNRMachine(); //CSQ״̬йԼҪԼ죬һǶźֵɵ״̬
                    }
                    else if (g_s_nbiot_task_flag == TASK_SUCCESS)
                    {
                        g_s_nbiot_mode_flag = NO_NBIOT_TASK;
                        g_s_nbiot_task_flag = TASK_INIT;
                        g_s_nbiot_main_state = NBIOT_S_IDLE;
                    }
                    else
                    {
                        g_s_nbiot_mode_flag = NO_NBIOT_TASK;
                        g_s_nbiot_task_flag = TASK_INIT;
                        g_s_nbiot_main_state = NBIOT_S_IDLE; //Ӧòùػ_
                    }
                }
                else
                {
                    g_s_nbiot_task_flag = TASK_INIT;
                    g_s_nbiot_main_state = NBIOT_POWER_INIT; //ģʼ
					StartNbiotInit();
                }
            }
        }
        break;
		/*
		case NBIOT_READ_UDP_DATA:
		{
            if (TASK_INIT == g_s_nbiot_task_flag)
            {
                UdpReadDataMachine();
            }
            else
            {
                g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE;
            }			
        }
        break;*/
		case NBIOT_REV_ACK:
		{
            if (TASK_INIT == g_s_nbiot_task_flag)
            {
                NbiotRevAckMachine(); 
            }
            else
            {
                g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE;
            }			
        }
        break;
		
		case NBIOT_PSM_WAKEUP:
		{
		    if (TASK_INIT == g_s_nbiot_task_flag)
            {
                Psm_Wakup_Machine(); 
            }
            else
            {
                g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE;
            }	
		}
		break;
		
		case NBIOT_PSM_SLEEP:
		{
			if (TASK_INIT == g_s_nbiot_task_flag)
            {
                Psm_Sleep_Machine(); 
            }
            else
            {
                g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE;
            }			
		}
        break;
		
        default:
        {
            g_s_nbiot_main_state = NBIOT_S_IDLE;
        }
        break;
    }
}
/***************************************************************************
 * @fun_name     u8 NbiotIfIdle()
 * @brief        ѯģĿ״̬
 ***************************************************************************/
u8 NbiotIfIdle(void)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
        return TASK_IDLE;
    }
    else
    {	
        return TASK_BUSY;
    }
}

/***************************************************************************
 * @fun_name     u8 NbiotIfOnline()
 * @brief        ѯNBIOTǷ
 ***************************************************************************/
u8 NbiotIfOnline(void)
{
    if (NB_ON_LINE == Nbiot_Para.net_state)
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

/***************************************************************************
 * @fun_name     u8 ConncetIfOnline()
 * @brief        ѯǷ
 ***************************************************************************/
u8 ConncetIfOnline(u8 connect_type)
{  
	if(connect_type == NBIOT_CONNECT_COAP)
	{
		if (CONNECT_ON_LINE == Nbiot_Para.coap_state)
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	else if(connect_type == NBIOT_CONNECT_UDP1)
	{
		if (CONNECT_ON_LINE == Nbiot_Para.udp1_state)
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	else if(connect_type == NBIOT_CONNECT_UDP2)
	{
		if (CONNECT_ON_LINE == Nbiot_Para.udp2_state)
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	return FALSE;
}

/***************************************************************************
 * @fun_name     void NbiotOnlineTask(u8 *state)
 * @brief        NBIOT
 * @param[in]    state:״̬Ϣ
 ***************************************************************************/
void NbiotOnlineTask(u8 *state)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
        if (!NbiotIfOnline())
        {
            if (NBIOT_S_IDLE == g_s_nbiot_main_state)
            {
                Nbiot_Send_Data.state = state; //ַ
                *state = NBIOT_ING;
                g_s_nbiot_mode_flag = ONLINE_MODE;
				g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_POWER_INIT;
				StartNbiotInit();
            }
        }
        else
        {
            *state = NBIOT_ONLINE;
        }
    }
    else
    {
        *state = NBIOT_ERROR;
    }
}
/***************************************************************************
 * @fun_name     void NB_NetConnectStart
 * @brief        ͽ
 * @param[in]    state:״̬Ϣ
 ***************************************************************************/
void NB_NetConnectStart(unsigned char* temp_ip, u16 temp_port, u8 connect_type)
{
	if(connect_type == NBIOT_CONNECT_COAP)
	{
		coap_ip = temp_ip;
		coap_port = temp_port;
		if(Nbiot_Para.Telecom == SIM_CARD_MOBILE)//ƶ
		{
			OneNetStartConnect(); 
		}
		else//ſ
		{
			CoapStartConnect();	
		}
		nbiot_temp_connect_type = NBIOT_CONNECT_COAP;
	}
	else if(connect_type == NBIOT_CONNECT_UDP1)
	{
		udp_ip1 = temp_ip;
		udp_port1 = temp_port;
		UdpStartConnect(NBIOT_CONNECT_UDP1);
	}
	else if(connect_type == NBIOT_CONNECT_UDP2)
	{
		udp_ip2 = temp_ip;
		udp_port2 = temp_port;
		UdpStartConnect(NBIOT_CONNECT_UDP2);
	}
	g_s_nbiot_task_flag = TASK_INIT;
	g_s_nbiot_main_state = NBIOT_NET_OPEN;
}
void NbiotPsmWakeupTask(void)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
		g_s_nbiot_task_flag = TASK_INIT;
		g_s_nbiot_main_state = NBIOT_PSM_WAKEUP;
		s_psm_wakeup_state = PSM_WKUPSTA_START;
    }
}
void NbiotPsmSleepTask(void)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
		g_s_nbiot_task_flag = TASK_INIT;
		g_s_nbiot_main_state = NBIOT_PSM_SLEEP;
		s_psm_sleep_state = PSM_SLPSTA_START;
    }
}
void NbiotPsmCheckTask(void)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
		g_s_nbiot_task_flag = TASK_INIT;
		g_s_nbiot_main_state = NBIOT_PSM_SLEEP;
		s_psm_sleep_state = PSM_CHECK_START;
    }
}
/***************************************************************************
 * @fun_name     void NbiotSendTask(u8 *addr, u16 len, u8 send_type,u8 *state)
 * @brief        NBIOTݷ
 * @param[in]    addrݵ׵ַ len
 * @param[out]   state:״̬Ϣ
 * @retval       None
 * @other        state(NBIOT_INGѯ, NBIOT_SUCCESɹ 쳣)
 ***************************************************************************/
void NbiotSendTask(u8 *addr, u16 len, u8 send_type,u8 *state)
{
    if ((NBIOT_S_IDLE == g_s_nbiot_main_state) && (len > 0) && (len <= UP_BUF_SIZE))
    {
        Nbiot_Send_Data.buf = addr; //ַ
        Nbiot_Send_Data.len = len; //ֵ
        Nbiot_Send_Data.state = state; //ַ
        *state = NBIOT_ING;
        g_s_nbiot_mode_flag = SEND_MODE;
		g_s_nbiot_send_type = send_type;
		g_s_nbiot_task_flag = TASK_INIT;
		g_s_nbiot_main_state = NBIOT_DATA_SEND;
		StartNbiotSendData();
    }
    else
    {
        *state = NBIOT_ERROR;
    }
}
//ȡ
u8 GetNbiotSendType(void)
{
	return g_s_nbiot_send_type;	
}
/***************************************************************************
 * @fun_name     void NbiotReadCsqTask(u8 *out_csq,u8 *state)
 * @brief        NBIOTѯźֵ
 * @param[in]    out_csqݵַ
 * @param[out]   state:״̬Ϣ
 * @retval       None
 * @other        state(CSQ_INGѯ, CSQ_SUCCESɹ 쳣)
 ***************************************************************************/
/*void NbiotUdpOpenTask(void)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
		if(!UdpIfOnline())
		{
			g_s_nbiot_mode_flag = ONLINE_MODE;
			g_s_nbiot_task_flag = TASK_INIT;
			g_s_nbiot_main_state = NBIOT_UDP_OPEN;
			UdpStartConnect();
		}        
    }   	
}*/

void NbiotReadECLSNRTask(u8 *state)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
        Nbiot_Send_Data.state = state;
        *state = ECL_SNR_ING;
        g_s_nbiot_mode_flag = READ_ECL_SNR;
        g_s_nbiot_read_ECL_flag = FALSE;
		g_s_nbiot_task_flag = TASK_INIT;
        g_s_nbiot_main_state = NBIOT_READ_ECL_SNR;
    }
    else
    {
        *state = ECL_SNR_ERROR;
    }
}


/***************************************************************************
 * @fun_name     u8 NbiotIfSleep()
 * @brief        Ƿ
 * @param[in]    None
 * @param[out]   None
 * @retval       TRUE:   FALSE:
 * @other        None
 ***************************************************************************/
u8 NbiotIfSleep(void)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

/***************************************************************************
 * @fun_name     void NbiotPreSleep()
 * @brief        ǰ
 * @param[in]    None
 * @param[out]   None
 * @retval       None
 * @other        None
 ***************************************************************************/
static void NbiotPreSleepNormal(void)
{
    NB_Power_Disable(); //жϵԴ
    UartPreSleep(NB_UART_COM);
    g_s_nbiot_main_state = NBIOT_S_IDLE;
	Nbiot_Para.coap_state = CONNECT_OFF_LINE;
	Nbiot_Para.udp1_state = CONNECT_OFF_LINE;
	Nbiot_Para.udp2_state = CONNECT_OFF_LINE;
    Nbiot_Para.net_state = NB_OFF_LINE;
	
	//NB
	stc_gpio_cfg_t stcGpioCfg;
	DDL_ZERO_STRUCT(stcGpioCfg);	
	stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ	
	stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->	
	stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
	stcGpioCfg.enPd = GpioPdDisable;	
	stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©
	stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB
	Gpio_Init(BAT_NB_PORT, BAT_NB_PIN, &stcGpioCfg);  //ģ鹩IO
    Gpio_Init(RSTN_NB_PORT, RSTN_NB_PIN, &stcGpioCfg);
    Gpio_Init(NB_PSM_WAKE_PORT, NB_PSM_WAKE_PIN, &stcGpioCfg);
    Gpio_Init(PWR_NB_PORT, PWR_NB_PIN, &stcGpioCfg);   //Դƽ
	
	Gpio_WriteOutputIO(BAT_NB_PORT, BAT_NB_PIN, FALSE);
    Gpio_WriteOutputIO(PWR_NB_PORT, PWR_NB_PIN, FALSE);
	Gpio_WriteOutputIO(RSTN_NB_PORT, RSTN_NB_PIN, FALSE); 
	Gpio_WriteOutputIO(NB_PSM_WAKE_PORT , NB_PSM_WAKE_PIN, FALSE);	
	
	Gpio_Init(LPUART1_TX_PORT, LPUART1_TX_PIN, &stcGpioCfg);
	Gpio_WriteOutputIO(LPUART1_TX_PORT, LPUART1_TX_PIN, FALSE);	//TXҲΪ
	
	stcGpioCfg.enDir = GpioDirIn;   //RX
	Gpio_Init(LPUART1_RX_PORT, LPUART1_RX_PIN, &stcGpioCfg);
}
static void NbiotPreSleepPsm(void)
{
    UartPreSleep(NB_UART_COM);
    g_s_nbiot_main_state = NBIOT_S_IDLE;
}
void NbiotPreSleep(void)
{
	if(Sys_data_object.P3.NBSleepMode == 1)//PSMģʽ
	{
		NbiotPreSleepPsm();
	}
	else
	{
		NbiotPreSleepNormal();
	}
}
/***************************************************************************
 * @fun_name    void NbiotWakeSleep()
 * @brief        ߺ
 * @param[in]    None
 * @param[out]   None
 * @retval       None
 * @other        None
 ***************************************************************************/
void NbiotWakeSleep(void)
{
  
}

/******************************ڲ״̬***********************************/
void StartNbiotInit(void)
{
	s_init_state = S_INIT_POWER_ON;
}
/***************************************************************************
 * @fun_name     void NbiotInitMachine()
 * @brief        NBIOTʼ״̬
 * @param[in] 	 None
 * @param[out] 	 None
 * @retval     	 None
 * @other        None
 ***************************************************************************/
#define MODULE_POWER_DELAY_TIME 1000  		//mS
#define MODULE_RESET_DELAY_TIME 1000  		//mS
//AT+QBAND  AT+QBAND=1,5 //ƵΪ BAND 5
//йƶΪ:898600;898602;898604;898607 й898603;898611
void NbiotInitMachine_BC25(void)
{
    static u8 s_at_error_count = 0; //¼ATָʱ  ָΪʧ
    
    static const char* c_AT = "AT\r";
    static const char* c_AT_IMEI = "AT+CGSN=1\r";
    static const char* c_AT_CIMI = "AT+CIMI\r";
    static const char* c_AT_ICCID = "AT+QCCID\r";//˸20200605
    static const char* c_AT_CMEE = "AT+CMEE=1\r"; //ERRORʾ
    static const char* c_AT_CPSMS = "AT+CPSMS=0\r"; //رPSMģʽ
    static const char* c_AT_NPTWEDRXS = "AT+CEDRXS=0\r"; //رeDRXģʽ
    static const char* c_AT_CSQ = "AT+CSQ\r"; //ѯźֵ
    static const char* c_AT_CEREG = "AT+CEREG?\r";
	static const char* c_AT_NCFG = "AT+NCFG=0,172800\r";//lifetime ƽ̨˵ ָʱ豸ʾߣ48Сʱ
    static const char* c_AT_CGATT = "AT+CGATT?\r";
    static u8 c_AT_CGDCONT_APN[APN_SIZE+50] = "AT+QCGDEFCONT=\"IP\",\""; //ָAPN,СΪ̶20ֽ+APNСټԤռ

    switch (s_init_state)
    {
        case S_INIT_POWER_ON://NBģ͵
        {  
			NbModuleIOInit();  //ʼĬģϵ
            UartInit(NB_UART_COM, BAUD9600, DATA_BIT_8, STOPBIT_1, UART_NONE_PARITY,UART_LPUART_Disable);	
            RSTN_NB_HIG();
            PWR_NB_LOW();//PWR_NB_HIG();
            NB_Power_Enable(); 						
            set_timer_1ms(5*MODULE_POWER_DELAY_TIME);//ȴ5,SIMʼ
            s_init_state = S_INIT_POWER_ON_WAIT;
        }
        break;

//        case S_INIT_PWRKEY_LOW://NBģ͵
//        {
//            if (!check_timer_1ms())
//            {
//                PWR_NB_LOW();
//                s_init_state = S_INIT_PWRKEY_HIGH;
//                set_timer_1ms(MODULE_RESET_DELAY_TIME*4);
//            }
//        }
//        break;

//        case S_INIT_PWRKEY_HIGH://NBģ͵
//        {
//            if (!check_timer_1ms())
//            {
//                PWR_NB_HIG();     //ߵƽ
//				set_timer_1s(5);
//				s_init_state = S_INIT_POWER_ON_WAIT;
//            }
//        }
//        break;


        case S_INIT_POWER_ON_WAIT://ȴģעʱ
        {
            if (!check_timer_1ms())
            {
                s_at_error_count = 0; //ATָ
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
				if(getUploadControlPara(UP_AT_SIMPLE)!=AT_SIMPLE_NULL)
				{ 
					s_init_state = S_INIT_ASK_CEREG;
				}
				else
				{
					s_init_state = S_INIT_ATS;
				}
            }
        }
        break;

        case S_INIT_ATS://"AT" ȷģ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT, strlen(c_AT), cst_AT_No_AT);
                s_init_state = S_INIT_ATS_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); //ԱATָصʱ300ms(ͺͽռõʱ)
            }
        }
        break;

        case S_INIT_ATS_R://ȴ"AT"Ӧ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_init_state = S_INIT_ASK_IMEI; //һʼѯIMEI
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR)) //Ӧʱߴ
            {
                if (++s_at_error_count >= NUM_AT_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_INIT_ASK_IMEI; //һʼѯIMEI
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ATS;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_INIT_ASK_IMEI: //ʼѯIMEI
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_IMEI, strlen(c_AT_IMEI), cst_AT_No_AT_IMEI);
                s_init_state = S_INIT_ASK_IMEI_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); 
            }
        }
        break;

        case S_INIT_ASK_IMEI_R://ȴIMEIӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_init_state = S_INIT_ASK_CIMI;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_CIMI_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_INIT_ASK_CIMI;
					set_timer_1ms(2 * AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ASK_IMEI;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_INIT_ASK_CIMI://ʼѯCIMI
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CIMI, strlen(c_AT_CIMI), cst_AT_No_AT_CIMI);
                s_init_state = S_INIT_ASK_CIMI_R;
                set_timer_1ms(6*AT_COMMAND_RECEIVE_WAIT_TIME);//ȥʱ,ȴSIMʼϳ
            }
        }
        break;

        case S_INIT_ASK_CIMI_R://ȴCIMIӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_init_state = S_INIT_ASK_ICCID; //ʼѯICCID
                set_timer_1ms(2*AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_CIMI_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_INIT_ASK_ICCID; //ʼѯICCID
					set_timer_1ms(2*AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ASK_CIMI;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_INIT_ASK_ICCID://ʼѯICCID
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_ICCID, strlen(c_AT_ICCID), cst_AT_No_AT_ICCID);
                s_init_state = S_INIT_ASK_ICCID_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); //ԱATָصʱ300ms(ͺͽռõʱ)
            }
        }
        break;

        case S_INIT_ASK_ICCID_R://ȴICCIDӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                //IMEI IMSI ICCID תȫRAM
                 sys_get_three_code();
                 s_init_state = S_INIT_CMEE; //һERRORʾ
                 set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_ICCID_ERROR)
                {
                    s_at_error_count = 0;
                    s_init_state = S_INIT_CMEE; //һERRORʾ
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ASK_ICCID;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_INIT_CMEE: //
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CMEE, strlen(c_AT_CMEE), cst_AT_No_AT_CMEE);
                s_init_state = S_INIT_CMEE_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); //ԱATָصʱ300ms(ͺͽռõʱ)
            }
        }
        break;

        case S_INIT_CMEE_R://ȴCMEEӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_init_state = S_TCP_CPSMS;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_CMEE_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_TCP_CPSMS;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_CMEE;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_TCP_CPSMS://ùرջPSMģʽ
        {
            if (!check_timer_1ms())
            {
				NbiotUartSend((u8*) c_AT_CPSMS, strlen(c_AT_CPSMS), cst_AT_No_AT_CPSMS);//رPSM
                s_init_state = S_TCP_CPSMS_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_TCP_CPSMS_R:
        {
            if (NbiotCheckAtAck() == UART_OK)//Ӧȷ-һ
            {
                s_at_error_count = 0;
                s_init_state = S_TCP_NPTWEDRXS;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_CPSMS_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_TCP_NPTWEDRXS;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_TCP_CPSMS;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_TCP_NPTWEDRXS://رeDRXģʽ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_NPTWEDRXS, strlen(c_AT_NPTWEDRXS), cst_AT_No_AT_NPTWEDRXS);
                s_init_state = S_TCP_NPTWEDRXS_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_TCP_NPTWEDRXS_R://رeDRXģʽ --ȴӦ
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
                s_init_state = S_INIT_AT_CGDCONT;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_NPTWEDRXS_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_INIT_AT_CGDCONT;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_TCP_NPTWEDRXS;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_INIT_AT_CGDCONT:
        {
            if(!check_timer_1ms())
            {
                u8 ip_apn = 20;
            
                int i;
				for(i = 0; i < Sys_data_object.P1.apn[1]; i++)
				{
					c_AT_CGDCONT_APN[ip_apn++] = Sys_data_object.P1.apn[2 + i];
				}
				c_AT_CGDCONT_APN[ip_apn++] = '"';
				c_AT_CGDCONT_APN[ip_apn++] = '\r';
				NbiotUartSend((u8*) c_AT_CGDCONT_APN, ip_apn, cst_AT_No_AT_CGDCONT);
				set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
				s_init_state = S_INIT_AT_CGDCONT_R;
            
            }
        }
        break;

        case S_INIT_AT_CGDCONT_R:
        {
            if (NbiotCheckAtAck() == UART_OK) 
            {
                s_at_error_count = 0;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
                s_init_state = S_INIT_ASK_CSQ;
            }
            else if ((NbiotCheckAtAck() == UART_ERROR) || (!check_timer_1ms()))
            {
                s_at_error_count++;
                if (s_at_error_count >= AT_ERROR)
                {
                    s_at_error_count = 0;
                    set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
					s_init_state = S_INIT_ASK_CSQ;
                }
                else
                {
                    s_init_state = S_INIT_AT_CGDCONT;
                }
            }
        }
        break;

        case S_INIT_ASK_CSQ://ѯCSQ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CSQ, strlen(c_AT_CSQ), cst_AT_No_AT_CSQ);
                s_init_state = S_INIT_ASK_CSQ_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); //ԱATָصʱ300ms(ͺͽռõʱ)
            }
        }
        break;

        case S_INIT_ASK_CSQ_R://ȴCSQӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                
                s_at_error_count = 0;
                
                s_init_state = S_INIT_ASK_CEREG; //ʼѯCEREG
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_CSQ_ERROR)
                {
                    
					s_at_error_count = 0;
					
					s_init_state = S_INIT_ASK_CEREG; //ʼѯCEREG
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ASK_CSQ;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_INIT_ASK_CEREG://ʼѯCEREG
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CEREG, strlen((const char*) c_AT_CEREG), cst_AT_No_AT_CEREG);
                s_init_state = S_INIT_ASK_CEREG_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME * 2); 
            }
        }
        break;

        case S_INIT_ASK_CEREG_R://ȴCEREGӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_init_state = S_INIT_SET_NCFG;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))//Ӧʱ
            {
				/*u8 NB_login_ask_times = FrameCheckParaApp(FramePara_NbParaLoginAckTimes);
                if (NB_login_ask_times < 30)
                {
                    NB_login_ask_times = 30;
                }
                if (NB_login_ask_times > 150)
                {
                    NB_login_ask_times = 150;
                }
                if (++s_at_error_count >= NB_login_ask_times)*/
				if (++s_at_error_count >= NUM_AT_CEREG_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_INIT_SET_NCFG;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ASK_CEREG;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;
		case S_INIT_SET_NCFG:
		{
		    if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_NCFG, strlen((const char*) c_AT_NCFG), cst_AT_No_AT);
                s_init_state = S_INIT_SET_NCFG_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME*2); 
            }	
		} 
		break;
		case S_INIT_SET_NCFG_R:
		{
		    if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
				s_at_error_count = 0;
				set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                s_init_state = S_INIT_ASK_CGATT;
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))//Ӧʱ
			{
			    s_at_error_count = 0;
				set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                s_init_state = S_INIT_ASK_CGATT;		
			}
		}
		break;
        case S_INIT_ASK_CGATT://ʼѯCGATT
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CGATT, strlen(c_AT_CGATT), cst_AT_No_AT_CGATT_how);
                s_init_state = S_INIT_ASK_CGATT_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME*2); 
            }
        }
        break;

        case S_INIT_ASK_CGATT_R://ȴCGATTӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
				s_at_error_count = 0;
				set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                s_init_state = S_INIT_ASK_NUESTATS;
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))//Ӧʱ
            {
                u8 NB_login_ask_times = FrameCheckParaApp(FramePara_NbParaLoginAckTimes);
                if (NB_login_ask_times < 30)
                {
                    NB_login_ask_times = 30;
                }
                if (NB_login_ask_times > 150)
                {
                    NB_login_ask_times = 150;
                }
                if (++s_at_error_count >= NB_login_ask_times)
                {
                    s_at_error_count = 0;
					g_s_nbiot_task_flag = TASK_FAIL; //ʼʧ
                    s_init_state = S_INIT_POWER_ON;
                }
                else
                {
                    s_init_state = S_INIT_ASK_CGATT;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;
		case S_INIT_ASK_NUESTATS:
        {
			if(!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_NUESTATS, strlen(c_AT_NUESTATS), cst_AT_No_AT_NUESTATS);
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
                s_init_state = S_INIT_ASK_NUESTATS_R;
            }
        }
        break;

        case S_INIT_ASK_NUESTATS_R:
        {
			if (NbiotCheckAtAck() == UART_OK)
			{
				//ȷӦ
				s_at_error_count = 0;
				set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
				s_init_state = S_INIT_ASK_CCLK;
			}
			else if(!check_timer_1ms())
			{
				//شӦ߶ʱʱ䵽
				s_at_error_count++;
				if (s_at_error_count >= NUM_AT_ECL_ERROR)
				{
					s_at_error_count = 0;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
					s_init_state = S_INIT_ASK_CCLK;
				}
				else
				{
					s_init_state = S_INIT_ASK_NUESTATS;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
				}
			}
        }
        break;
		
		case S_INIT_ASK_CCLK://ʼѯʱ
        {
            if(!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CCLK, strlen(c_AT_CCLK), cst_AT_No_AT_CCLK);
                s_init_state = S_INIT_ASK_CCLK_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_INIT_ASK_CCLK_R://ȴӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                g_s_nbiot_task_flag = TASK_SUCCESS; //ʼɹ
                s_init_state = S_INIT_POWER_ON; // ָ뷵
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))//Ӧʱ
            {
                if (++s_at_error_count >= NUM_AT_CCLK_ERROR)
                {
					s_at_error_count = 0;
					g_s_nbiot_task_flag = TASK_SUCCESS; //ʼɹ
					s_init_state = S_INIT_POWER_ON; // ָ뷵
                }
                else
                {
                    s_init_state = S_INIT_ASK_CCLK;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;
        default:
        {
            s_at_error_count = 0;
			s_init_state = S_INIT_POWER_ON;
        }
        break;
    }
}
void NbiotInitMachine(void)
{
    NbiotInitMachine_BC25();
}
//
void CoapStartConnect(void)
{
	s_coap_connect_state = S_COAP_CONNECT_START;
}
/***************************************************************************
 * @fun_name     static void CoapConnectMachine()
 * @brief        Coap״̬
 ***************************************************************************/
void CoapConnectMachine_BC25(void)
{
    static u8 s_at_error_count = 0;
    unsigned char *nbiot_ip;
    u16 nbiot_port;
    static char c_AT_NCDP[50] = "AT+NCDPOPEN=\"117.060.157.137\",05683\r"; //
    static const char* c_AT_NCDP_CK = "AT+NMSTATUS?\r"; //
	
    switch (s_coap_connect_state)
    {
        case S_COAP_CONNECT_START: //ʼ
        {
            s_at_error_count=0;
            s_coap_connect_state = S_COAP_NCDP;
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;

        case S_COAP_NCDP:
        {
            if (!check_timer_1ms())
            {
				u16 len = 13; //ATָĳȣݷͳȵλ
				nbiot_port = coap_port;//Sys_data_object.P1.server_port.datas;
				nbiot_ip = coap_ip;//Sys_data_object.P1.server_ip;

				//IP Ĵ洢Ȼʹˮԭʽ桰.ţʹʱ
				int i;
				for (i = 0; i < 4; i++)
				{
					if (nbiot_ip[i] < 10)
					{
						c_AT_NCDP[len++] = nbiot_ip[i] + 0x30;
					}
					else if (nbiot_ip[i] < 100)
					{
						c_AT_NCDP[len++] = (nbiot_ip[i] / 10) + 0x30;
						c_AT_NCDP[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					else
					{
						c_AT_NCDP[len++] = (nbiot_ip[i] / 100) + 0x30;
						c_AT_NCDP[len++] = (nbiot_ip[i] / 10) % 10 + 0x30;
						c_AT_NCDP[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					c_AT_NCDP[len++] = '.';
				}
				len--; //ĵ
				c_AT_NCDP[len++] = '\"';
				c_AT_NCDP[len++] = ',';
				c_AT_NCDP[len++] = ((nbiot_port) / 10000) + 0x30;
				c_AT_NCDP[len++] = (((nbiot_port) % 10000) / 1000) + 0x30;
				c_AT_NCDP[len++] = (((nbiot_port) % 1000) / 100) + 0x30;
				c_AT_NCDP[len++] = (((nbiot_port) % 100) / 10) + 0x30;
				c_AT_NCDP[len++] = ((nbiot_port) % 10) + 0x30;
				c_AT_NCDP[len++] = '\r';
				NbiotUartSend((u8*)c_AT_NCDP, len, cst_AT_No_AT_NCDP);
				set_timer_1s(35);
				s_coap_connect_state = S_COAP_NCDP_R;
            }
        }
        break;

        case S_COAP_NCDP_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
				s_at_error_count=0;
				s_coap_connect_state = S_COAP_NCDP_CK;
				set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if (!check_timer_1s() || NbiotCheckAtAck() == UART_ERROR)
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_NCDP_ERROR)//
                {
					s_at_error_count = 0;
					*Nbiot_Send_Data.state = NBIOT_ERROR;//ʧ
					s_coap_connect_state = S_COAP_CONNECT_START; 
					g_s_nbiot_task_flag = TASK_FAIL;
                }
                else
                {
                    s_coap_connect_state = S_COAP_NCDP;
                }
            }
        }
        break;

        case S_COAP_NCDP_CK:
        {
            if(!check_timer_1ms())
            {
				NbiotUartSend((u8*) c_AT_NCDP_CK, strlen(c_AT_NCDP_CK), cst_AT_No_AT_NCDP_CK);
				set_timer_1s(2);
				s_coap_connect_state = S_COAP_NCDP_CK_R;
            }
        }
        break;

        case S_COAP_NCDP_CK_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
               	*Nbiot_Send_Data.state = NBIOT_ONLINE;
				s_coap_connect_state = S_COAP_CONNECT_START; 
				g_s_nbiot_task_flag = TASK_SUCCESS;
            }
            else if((!check_timer_1s()))
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_NCDP_CK_ERROR)
                {
					s_at_error_count = 0;
					*Nbiot_Send_Data.state = NBIOT_ERROR;
					s_coap_connect_state = S_COAP_CONNECT_START; 
					g_s_nbiot_task_flag = TASK_FAIL; 
                }
                else
                {
                    s_coap_connect_state = S_COAP_NCDP_CK;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;
        default:
        {
            s_coap_connect_state = S_COAP_CONNECT_START; //״̬عʼ״̬
        }
        break;
    }
}
void CoapConnectMachine()
{
    CoapConnectMachine_BC25();
}
void StartNbiotSendData(void)
{
	if(g_s_nbiot_send_type == SEND_TYPE_COAP)
	{
		if(Nbiot_Para.Telecom == SIM_CARD_MOBILE)//ƶ
		{
			StartOnenetSendData();
		}
		else//ſ
		{
			StartCoapSendData(); //ݷ״̬
		}
	}
	else if(g_s_nbiot_send_type == SEND_TYPE_UDP1)
	{
		StartUdpSendData(); //ݷ״̬
		UdpStartCheckData();//ѯUDP
	}
	else if(g_s_nbiot_send_type == SEND_TYPE_UDP2)
	{
		StartUdpSendData(); //ݷ״̬
		UdpStartCheckData();//ѯUDP
	}
}

#if SEND_ACKID_ENABLE
u16 Send_AckID = 0;
#endif


//
void StartCoapSendData(void)
{
	s_coap_send_state = S_SEND_START;
}

void CoapSendDataMachine_BC25(void)
{
    static u8 s_at_error_count = 0; //ATָۼƷʧܴ
    static const u8 temp_AT_Buffer[]= {"AT+NMGS="};
    switch (s_coap_send_state)
    {
        case S_SEND_START:
        {
            s_coap_send_state = S_SEND_DATA; //յݷͣģᱨERRORʱ1SERROR
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;

        case S_SEND_DATA:
        {
            if (!check_timer_1ms())
            {
                u16 len = 8; //ATָĳȣݷͳȵλ
                int i;
                for(i=0; i<8; i++)
                {
                    c_AT_NMGS[i]=temp_AT_Buffer[i];
                }
                c_AT_NMGS[len++] = (Nbiot_Send_Data.len / 10000) + 0x30;
                c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 10000) / 1000 + 0x30;
                c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 1000) / 100 + 0x30;
                c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 100) / 10 + 0x30;
                c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 10) + 0x30;
                c_AT_NMGS[len++] = ',';
                //
                for (i = 0; i < Nbiot_Send_Data.len; i++)//ȡ
                {
                    if ((*(Nbiot_Send_Data.buf + i) >> 4) >= 0x0A)
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x37;
                    }
                    else
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x30;
                    }

                    if ((*(Nbiot_Send_Data.buf + i) & 0x0F) >= 0x0A)
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x37;
                    }
                    else
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x30;
                    }
                }
				if((Sys_data_object.P1.func_cfg_bytes[12]&0x80)&&(Sys_data_object.P1.func_cfg_bytes[12]&0x03)) //PSMģʽϱж
				{
						c_AT_NMGS[len++] = ',';
						c_AT_NMGS[len++] = '1';
						c_AT_NMGS[len++] = '0';
						c_AT_NMGS[len++] = '0';//c_AT_NMGS[len++] = '2';
						c_AT_NMGS[len++] = '\r';
						NbiotUartSend((u8*) c_AT_NMGS, len, cst_AT_No_AT_NMGS_ACKID);
				}
				else
				{
					if((Sys_data_object.P1.func_cfg_bytes[10] == 0x55)||(Sys_data_object.P3.ProductUploadFlag == 0x55))//ACKϱɹ
					{
						c_AT_NMGS[len++] = ',';
						c_AT_NMGS[len++] = '1';
						c_AT_NMGS[len++] = '0';
						c_AT_NMGS[len++] = '0';
						c_AT_NMGS[len++] = '\r';
						NbiotUartSend((u8*) c_AT_NMGS, len, cst_AT_No_AT_NMGS_ACKID);
					}
					else
					{
						c_AT_NMGS[len++] = '\r';
						NbiotUartSend((u8*) c_AT_NMGS, len, cst_AT_No_AT_NMGS);
					}
				}
                set_timer_1s(4);
                s_coap_send_state = S_SEND_DATA_R;
            }
        }
        break;

        case S_SEND_DATA_R:
        {
            if (NbiotCheckAtAck() == UART_OK) //ȷӦ
            {
                s_at_error_count = 0;
                g_s_nbiot_task_flag = TASK_SUCCESS;
                *Nbiot_Send_Data.state = NBIOT_SUCCESS;
                s_coap_send_state = S_SEND_START;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1s()))
            {
                s_at_error_count++;
                if (s_at_error_count >= 1)
                {
                    s_at_error_count = 0;
                    *Nbiot_Send_Data.state = NBIOT_ERROR;
                    g_s_nbiot_task_flag = TASK_FAIL;
                    s_coap_send_state = S_SEND_START;
                }
                else
                {
                    s_coap_send_state = S_SEND_DATA_R;
                }
            }
        }
        break;

        default:
        {
            s_coap_send_state = S_SEND_START;
        }
        break;
    }
}
void CoapSendDataMachine(void)
{
    CoapSendDataMachine_BC25();
}

//UDP
void UdpStartConnect(u8 udp_num)
{
	nbiot_temp_connect_type = udp_num;
	s_udp_connect_state = S_UDP_CONNECT_START;
}
/***************************************************************************
 * @fun_name     void UdpConnectMachine(void)
 * @brief        UDP״̬
 ***************************************************************************/
void UdpConnectMachine_BC25(void)
{
    static u8 s_at_error_count = 0;
    
	unsigned char *nbiot_ip;
    u16 nbiot_port;	
    static char c_AT_QIOPEN[100];// = "AT+QIOPEN=1,0,\"UDP SERVICE\",\"60.208.16.57\",0,8080,0\r"; //   
	static const char* c_AT_QICFG = "AT+QICFG=\"showlength\",1\r"; //ʾݳ
    switch (s_udp_connect_state)
    {
        case S_UDP_CONNECT_START: //ʼ
        {
            s_at_error_count=0;
            s_udp_connect_state = S_UDP_QICFG;
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;
        case S_UDP_QICFG://ʾݳ
        {
            if (!check_timer_1ms())
            {
				NbiotUartSend((u8*) c_AT_QICFG, strlen(c_AT_QICFG), cst_AT_No_AT_QICFG);//ǷʾѡȲ
                s_udp_connect_state = S_UDP_QICFG_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_UDP_QICFG_R:
        {
            if (NbiotCheckAtAck() == UART_OK)//Ӧȷ-һ
            {
                s_at_error_count = 0;
                s_udp_connect_state = S_UDP_QIOPEN;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_QICFG_ERROR)
                {
                    s_at_error_count = 0;
					s_udp_connect_state = S_UDP_QIOPEN;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_udp_connect_state = S_UDP_QIOPEN;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_UDP_QIOPEN:
        {
            if (!check_timer_1ms())
            {
				u16 len = 21; //ATָĳȣݷͳȵλ
				char strings_temp[50];
				memset(c_AT_QIOPEN,0,sizeof(c_AT_QIOPEN));
				memset(strings_temp,0,sizeof(strings_temp));
				strcpy(c_AT_QIOPEN,"AT+QIOPEN=1,0,\"UDP\",\"");
				if(nbiot_temp_connect_type == NBIOT_CONNECT_UDP1)
				{
					nbiot_port = udp_port1;
					nbiot_ip = udp_ip1;
					c_AT_QIOPEN[12] = '0';//socket
				}
				else if(nbiot_temp_connect_type == NBIOT_CONNECT_UDP2)
				{
					nbiot_port = udp_port2;
					nbiot_ip = udp_ip2;
					c_AT_QIOPEN[12] = '1';//socket
				}
				//IP Ĵ洢Ȼʹˮԭʽ桰.ţʹʱ
				for (int i = 0; i < 4; i++)
				{
					if (nbiot_ip[i] < 10)
					{
						c_AT_QIOPEN[len++] = nbiot_ip[i] + 0x30;
					}
					else if (nbiot_ip[i] < 100)
					{
						c_AT_QIOPEN[len++] = (nbiot_ip[i] / 10) + 0x30;
						c_AT_QIOPEN[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					else
					{
						c_AT_QIOPEN[len++] = (nbiot_ip[i] / 100) + 0x30;
						c_AT_QIOPEN[len++] = (nbiot_ip[i] / 10) % 10 + 0x30;
						c_AT_QIOPEN[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					c_AT_QIOPEN[len++] = '.';
				}
				len--; //ĵ
				c_AT_QIOPEN[len++] = '\"';
				c_AT_QIOPEN[len++] = ',';
				c_AT_QIOPEN[len++] = ((nbiot_port) / 10000) + 0x30;
				c_AT_QIOPEN[len++] = (((nbiot_port) % 10000) / 1000) + 0x30;
				c_AT_QIOPEN[len++] = (((nbiot_port) % 1000) / 100) + 0x30;
				c_AT_QIOPEN[len++] = (((nbiot_port) % 100) / 10) + 0x30;
				c_AT_QIOPEN[len++] = ((nbiot_port) % 10) + 0x30;
				c_AT_QIOPEN[len++] = ',';
				c_AT_QIOPEN[len++] = '0';
				c_AT_QIOPEN[len++] = ',';
				c_AT_QIOPEN[len++] = '1'; //0: Buffer ģʽ; 1:Direct Push ģʽ
				c_AT_QIOPEN[len++] = '\r';

				len = strlen(c_AT_QIOPEN);              
				NbiotUartSend((u8*)c_AT_QIOPEN, len, cst_AT_No_AT_QIOPEN);
				set_timer_1ms(2*AT_COMMAND_RECEIVE_WAIT_TIME);
				s_udp_connect_state = S_UDP_QIOPEN_R;
            }
        }
        break;

        case S_UDP_QIOPEN_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
				s_at_error_count = 0;                
				//s_udp_connect_state = S_UDP_NUESTATS;
				s_udp_connect_state = S_UDP_Wait;
				set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if (!check_timer_1ms() || NbiotCheckAtAck() == UART_ERROR)
            {
                s_at_error_count++;
                if (s_at_error_count >= AT_ERROR)
                {
					//һ㲻ᷢ,϶ܲ鵽ؽ
					s_at_error_count = 0;
					s_udp_connect_state = S_UDP_NUESTATS;
					//s_udp_connect_state = S_UDP_Wait;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_udp_connect_state = S_UDP_QIOPEN;
                }
            }
        }
        break;

		case S_UDP_NUESTATS:
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_NUESTATS, strlen(c_AT_NUESTATS), cst_AT_No_AT_NUESTATS);
                set_timer_1ms(2*AT_COMMAND_RECEIVE_WAIT_TIME);
                s_udp_connect_state = S_UDP_NUESTATS_R;
            }
        }
        break;

        case S_UDP_NUESTATS_R:
        {
			if (NbiotCheckAtAck() == UART_OK)
			{
				//ȷӦ
				s_at_error_count = 0;
				set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
				s_udp_connect_state = S_UDP_CCLK;
			}
			else if (!check_timer_1ms() || NbiotCheckAtAck() == UART_ERROR)
			{
				//شӦ߶ʱʱ䵽
				s_at_error_count++;
				if (s_at_error_count >= NUM_AT_ECL_ERROR)
				{
					s_at_error_count = 0;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
					s_udp_connect_state = S_UDP_CCLK;
				}
				else
				{
					s_udp_connect_state = S_UDP_NUESTATS;	
				}
			}
        }
        break;
		
		case S_UDP_CCLK://ʼѯʱ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CCLK, strlen(c_AT_CCLK), cst_AT_No_AT_CCLK);
                s_udp_connect_state = S_UDP_CCLK_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); 
            }
        }
        break;

        case S_UDP_CCLK_R://ȴӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_udp_connect_state = S_UDP_Wait;
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))//Ӧʱ
            {
                if (++s_at_error_count >= NUM_AT_CCLK_ERROR)
                {
                    s_at_error_count = 0;
                    s_udp_connect_state = S_UDP_Wait;
                }
                else
                {
                    s_udp_connect_state = S_UDP_CCLK;
                }
            }
        }
        break;
		
        case S_UDP_Wait:
        {
            if((!check_timer_1ms()))
            {
                s_at_error_count = 0;
                *Nbiot_Send_Data.state = NBIOT_ONLINE;
                s_udp_connect_state = S_UDP_CONNECT_START; //״̬عʼ״̬
                g_s_nbiot_task_flag = TASK_SUCCESS; //Ϊֹɹ
            }
        }
        break;

        default:
        {
            s_udp_connect_state = S_UDP_CONNECT_START; //״̬عʼ״̬
        }
        break;
    }
}
void UdpConnectMachine(void)
{
   UdpConnectMachine_BC25();
}
//
void StartUdpSendData(void)
{
	s_udp_send_state = S_SEND_START;
}
//
void UdpSendDataMachine_BC25(void)
{
    static u8 s_at_error_count = 0; //ATָۼƷʧܴ
	static const u8 temp_AT_Buffer[]= {"AT+QISENDEX=0,"};
    switch (s_udp_send_state)
    {
        case S_SEND_START:
        {
            s_udp_send_state = S_SEND_DATA; //յݷͣģᱨERRORʱ1SERROR
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;

        case S_SEND_DATA:
        {
            if (!check_timer_1ms())
            {
                u16 len = 14; //ATָĳȣݷͳȵλ
                int i;
			    for(i=0; i<14; i++)
                {
                    c_AT_NMGS[i]=temp_AT_Buffer[i];
                }
				if(g_s_nbiot_send_type == SEND_TYPE_UDP1)
				{
					c_AT_NMGS[12] = '0';//socket
				}
				else if(g_s_nbiot_send_type == SEND_TYPE_UDP2)
				{
					c_AT_NMGS[12] = '1';//socket
				}
				
                c_AT_NMGS[len++] = (Nbiot_Send_Data.len / 10000) + 0x30;
                c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 10000) / 1000 + 0x30;
                c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 1000) / 100 + 0x30;
                c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 100) / 10 + 0x30;
                c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 10) + 0x30;
                c_AT_NMGS[len++] = ',';
				c_AT_NMGS[len++] = '\"';
                //
								
                for (i = 0; i < Nbiot_Send_Data.len; i++)//ȡ
                {
                    if ((*(Nbiot_Send_Data.buf + i) >> 4) >= 0x0A)
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x37;
                    }
                    else
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x30;
                    }

                    if ((*(Nbiot_Send_Data.buf + i) & 0x0F) >= 0x0A)
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x37;
                    }
                    else
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x30;
                    }
                }
				c_AT_NMGS[len++] = '\"';
                c_AT_NMGS[len++] = '\r';
                NbiotUartSend((u8*) c_AT_NMGS, len, cst_AT_No_AT_NMGS);
                set_timer_1s(4);
                s_udp_send_state = S_SEND_DATA_R;
            }
        }
        break;

        case S_SEND_DATA_R:
        {
            if (NbiotCheckAtAck() == UART_OK) //ȷӦ
            {
                s_at_error_count = 0;
                g_s_nbiot_task_flag = TASK_SUCCESS;
                *Nbiot_Send_Data.state = NBIOT_SUCCESS;
                s_udp_send_state = S_SEND_START;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1s()))
            {
                s_at_error_count++;
                if (s_at_error_count >= 1)
                {
                    s_at_error_count = 0;
                    *Nbiot_Send_Data.state = NBIOT_ERROR;
                    g_s_nbiot_task_flag = TASK_SUCCESS;
                    s_udp_send_state = S_SEND_START;
                }
                else
                {
					set_timer_1s(4);
                    s_udp_send_state = S_SEND_DATA;
                }
            }
        }
        break;

        default:
        {
            s_udp_send_state = S_SEND_START;
        }
        break;
    }
}
void UdpSendDataMachine(void)
{
	UdpSendDataMachine_BC25();
}
/*
void UdpReadDataMachine_BC25(void)
{
    static u8 s_error_count; //ATָۼƷʧܴ
    static u8 s_read_upd_data_state = S_START;
    static const char* c_AT_QIRD1 = "AT+QIRD=0,512\r";
	static const char* c_AT_QIRD2 = "AT+QIRD=1,512\r";
    switch (s_read_upd_data_state)
    {
        case S_START:
        {
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME*2);
            s_error_count = 0;
            s_read_upd_data_state = S_AT_QIRD;
        }
        break;

        case S_AT_QIRD:
        {
            if (!check_timer_1ms())
            {
				if(GetRcvDataType() == NB_RCV_UDP1_DATA)
				{
					 NbiotUartSend((u8*) c_AT_QIRD1, strlen((const char*) c_AT_QIRD1), cst_AT_No_AT_UPD_READ);
				}
				else if(GetRcvDataType() == NB_RCV_UDP2_DATA)
				{
					 NbiotUartSend((u8*) c_AT_QIRD2, strlen((const char*) c_AT_QIRD2), cst_AT_No_AT_UPD_READ);
				}
                set_timer_1ms(5*AT_COMMAND_RECEIVE_WAIT_TIME);
                s_read_upd_data_state = S_AT_QIRD_R;
            }
        }
        break;

        case S_AT_QIRD_R:
        {
			if (NbiotCheckAtAck() == UART_OK)
			{
				//ȷӦ
				*Nbiot_Send_Data.state = QIRD_SUCCESS;
				g_s_nbiot_task_flag = TASK_SUCCESS;
				s_read_upd_data_state = S_START;								
			}
			else if (!check_timer_1ms())
			{
				//شӦ߶ʱʱ䵽
				s_error_count++;
				if (s_error_count >= 3)
				{
					s_error_count = 0;
					*Nbiot_Send_Data.state = QIRD_ERROR;
					g_s_nbiot_task_flag = TASK_FAIL;
					s_read_upd_data_state = S_START;
				}
				else
				{
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME*5);
					s_read_upd_data_state = S_AT_QIRD;
				}
			}            
        }
        break;
		
        default:
        {
            s_read_upd_data_state = S_START;
        }
        break;
    }	
}
void UdpReadDataMachine(void)
{
   UdpReadDataMachine_BC25();
}*/
//
//OnenetConnectMachine
u8 s_onenet_connect_state=0;
void OneNetStartConnect(void)
{
	s_onenet_connect_state = S_ONENET_CONNECT_START;
}
/***************************************************************************
 * @fun_name     static void CoapConnectMachine()
 * @brief        Coap״̬
 ***************************************************************************/
void OnenetConnectMachine(void)
{
    static u8 s_at_error_count = 0;
    unsigned char *nbiot_ip;
    u16 nbiot_port;
	static char c_AT_MIPLCONFIG[40]="AT+MIPLCONFIG=0,183.230.040.040,05683\r";
	static const char* c_AT_MIPLCONFIG_CK="AT+MIPLCONFIG?\r";//+MIPLCONFIG: 0,183.230.40.40,5683 +MIPLCONFIG: 2,2 +MIPLCONFIG: 3,1 +MIPLCONFIG: 4,0,1
	static const char* c_AT_MIPLCREATE="AT+MIPLCREATE\r";
	static const char* c_AT_MIPLADDOBJ = "AT+MIPLADDOBJ=0,3200,1,\"1\",4,2\r";
	static const char* c_AT_MIPLOPEN ="AT+MIPLOPEN=0,600,60\r";
	static const char* c_AT_MIPLOPENPSM ="AT+MIPLOPEN=0,172800,60\r";
	static char c_AT_MIPLDISCOVERRSP[30];// AT+MIPLDISCOVERRSP=0,48839,1,4,"5750"
	
    switch (s_onenet_connect_state)
    {
		case S_ONENET_CONNECT_IDLE:
		{
		    break;
		}
        case S_ONENET_CONNECT_START: //ʼ
        {
            s_at_error_count=0;
            s_onenet_connect_state = S_ONENET_MIPLCONFIG;
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;

        case S_ONENET_MIPLCONFIG:
        {
            if (!check_timer_1ms())
            {
				u16 len = 16; //ATָĳȣݷͳȵλ
				nbiot_port = Sys_data_object.P1.server_port.datas;
				nbiot_ip = Sys_data_object.P1.server_ip;

				//IP Ĵ洢Ȼʹˮԭʽ桰.ţʹʱ
				int i;
				for (i = 0; i < 4; i++)
				{
					if (nbiot_ip[i] < 10)
					{
						c_AT_MIPLCONFIG[len++] = nbiot_ip[i] + 0x30;
					}
					else if (nbiot_ip[i] < 100)
					{
						c_AT_MIPLCONFIG[len++] = (nbiot_ip[i] / 10) + 0x30;
						c_AT_MIPLCONFIG[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					else
					{
						c_AT_MIPLCONFIG[len++] = (nbiot_ip[i] / 100) + 0x30;
						c_AT_MIPLCONFIG[len++] = (nbiot_ip[i] / 10) % 10 + 0x30;
						c_AT_MIPLCONFIG[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					c_AT_MIPLCONFIG[len++] = '.';
				}
				len--; //ĵ
				c_AT_MIPLCONFIG[len++] = ',';
				//c_AT_MIPLCONFIG[len++] = ((nbiot_port) / 10000) + 0x30;
				c_AT_MIPLCONFIG[len++] = (((nbiot_port) % 10000) / 1000) + 0x30;
				c_AT_MIPLCONFIG[len++] = (((nbiot_port) % 1000) / 100) + 0x30;
				c_AT_MIPLCONFIG[len++] = (((nbiot_port) % 100) / 10) + 0x30;
				c_AT_MIPLCONFIG[len++] = ((nbiot_port) % 10) + 0x30;
				c_AT_MIPLCONFIG[len++] = '\r';
				NbiotUartSend((u8*)c_AT_MIPLCONFIG, len, cst_AT_No_AT_MIPLCONFIG);
				set_timer_1s(5);
				s_onenet_connect_state = S_ONENET_MIPLCONFIG_R;
            }
        }
        break;
		
		case S_ONENET_MIPLCONFIG_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
				s_onenet_connect_state = S_ONENET_MIPLCONFIG_CK;
				set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if (!check_timer_1s() || NbiotCheckAtAck() == UART_ERROR)
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_MIPLCONF_ERROR)//
                {
					s_at_error_count = 0;
					s_onenet_connect_state = S_ONENET_MIPLCONFIG_CK;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_onenet_connect_state = S_ONENET_MIPLCONFIG;
                }
            }
        }
        break;
		
        case S_ONENET_MIPLCONFIG_CK:
        {
			 if (!check_timer_1ms())
			 {
				NbiotUartSend((u8*)c_AT_MIPLCONFIG_CK, strlen(c_AT_MIPLCONFIG_CK), cst_AT_No_AT_MIPLCONFIG_CK);
				s_onenet_connect_state = S_ONENET_MIPLCONFIG_CK_R;
				set_timer_1s(2);
			 }
        }
        break;
		
		case S_ONENET_MIPLCONFIG_CK_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
                s_onenet_connect_state = S_ONENET_MIPLCREATE;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if (!check_timer_1s())
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_MIPLCONF_ERROR)//
                {
					//һ㲻ᷢ,϶ܲ鵽ؽ
					s_at_error_count = 0;
					s_onenet_connect_state = S_ONENET_MIPLCREATE;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_onenet_connect_state = S_ONENET_MIPLCONFIG_CK;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_ONENET_MIPLCREATE:
        {
            if(!check_timer_1ms())
            {
				NbiotUartSend((u8*) c_AT_MIPLCREATE, strlen(c_AT_MIPLCREATE), cst_AT_No_AT_MIPLCREATE);
				set_timer_1s(2);
				s_onenet_connect_state = S_ONENET_MIPLCREATE_R;		
            }
        }
        break;

        case S_ONENET_MIPLCREATE_R:
        {
            if(NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
                s_onenet_connect_state = S_ONENET_MIPLADDOBJ;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if(!check_timer_1s())
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_MIPLCREATE_ERROR)
                {
					s_at_error_count = 0;
					s_onenet_connect_state = S_ONENET_MIPLADDOBJ;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_onenet_connect_state = S_ONENET_MIPLCREATE;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;
		
		case S_ONENET_MIPLADDOBJ:
        {
            if(!check_timer_1ms())
            {
				NbiotUartSend((u8*) c_AT_MIPLADDOBJ, strlen(c_AT_MIPLADDOBJ), cst_AT_No_AT_MIPLADDOBJ);
				set_timer_1s(2);
				s_onenet_connect_state = S_ONENET_MIPLADDOBJ_R;
            }
        }
        break;

        case S_ONENET_MIPLADDOBJ_R:
        {
            if(NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
                s_onenet_connect_state = S_ONENET_MIPLOPEN;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if((!check_timer_1s()))
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_MIPLADDOBJ_ERROR)
                {
					s_at_error_count = 0;
					s_onenet_connect_state = S_ONENET_MIPLOPEN;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_onenet_connect_state = S_ONENET_MIPLADDOBJ;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;
		
		case S_ONENET_MIPLOPEN:
        {
            if(!check_timer_1ms())
            {
				if((Sys_data_object.P1.func_cfg_bytes[12]&0x80)&&(Sys_data_object.P1.func_cfg_bytes[12]&0x03)) //PSMģʽϱж
				{
					NbiotUartSend((u8*) c_AT_MIPLOPEN, strlen(c_AT_MIPLOPENPSM), cst_AT_No_AT_MIPLOPEN);
				}
				else
				{
					NbiotUartSend((u8*) c_AT_MIPLOPEN, strlen(c_AT_MIPLOPEN), cst_AT_No_AT_MIPLOPEN);
				}
				set_timer_1s(10);
				s_onenet_connect_state = S_ONENET_MIPLOPEN_R;
            }
        }
        break;

        case S_ONENET_MIPLOPEN_R:
        {
            if(NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
				NbiotClearAtAck();
				NbiotSetRevMipldiscover(); 
				set_timer_1s(20);
                s_onenet_connect_state = S_ONENET_MIPLDISCOVER;
            }
            else if((!check_timer_1s()))
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_MIPLOPEN_ERROR)
                {
					s_at_error_count = 0;
					set_timer_1s(10);
					s_onenet_connect_state = S_ONENET_MIPLDISCOVER;			
                }
                else
                {
                    s_onenet_connect_state = S_ONENET_MIPLOPEN;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;
		case S_ONENET_MIPLDISCOVER: //static char c_AT_MIPLDISCOVERRSP[30];// AT+MIPLDISCOVERRSP=0,48839,1,4,"5750"
		{			
			if (NbiotCheckAtAck() == UART_OK)	
            {
				u8 len;
				char discover_num[10];
				memset(discover_num,0,sizeof(discover_num));
				memset(c_AT_MIPLDISCOVERRSP,0,sizeof(c_AT_MIPLDISCOVERRSP));
				strcpy(c_AT_MIPLDISCOVERRSP,"AT+MIPLDISCOVERRSP=0,");
				
				NbiotGetDiscover_num(discover_num);
				strcat(c_AT_MIPLDISCOVERRSP,discover_num);
				strcat(c_AT_MIPLDISCOVERRSP,",1,4,\"5750\"\r");
				
				len = strlen(c_AT_MIPLDISCOVERRSP);
				NbiotUartSend((u8*)c_AT_MIPLDISCOVERRSP, len, cst_AT_No_AT);
				set_timer_1s(2);
				
				s_onenet_connect_state = S_ONENET_MIPLDISCOVER_R; 	
            }
			else if(!check_timer_1s())
			{
				s_at_error_count = 0;
				*Nbiot_Send_Data.state = NBIOT_ERROR;
				g_s_nbiot_task_flag = TASK_FAIL; //Ϊֹɹ 
				s_onenet_connect_state = S_ONENET_CONNECT_IDLE;
			}
		} 
		break; 
          
		case S_ONENET_MIPLDISCOVER_R://Ӧյ--ȴӦ
		{
			if(NbiotCheckAtAck() == UART_OK)
			{
				s_at_error_count = 0;
				set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
				s_onenet_connect_state = S_ONENET_Wait;
			}
			else if((!check_timer_1s()))
			{
				s_at_error_count++;
				if (s_at_error_count >= NUM_AT_MIPLDISCOVERRSP_ERROR)
				{
					s_at_error_count = 0;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
					s_onenet_connect_state = S_ONENET_Wait;
				}
				else
				{
					NbiotClearAtAck();
					NbiotSetRevMipldiscover();
					s_onenet_connect_state = S_ONENET_MIPLDISCOVER;
					set_timer_1s(5);
				}
			}
		}  
		break;  
		
		case S_ONENET_Wait:
        {
            if((!check_timer_1ms()))
            {
				s_at_error_count = 0;
				 *Nbiot_Send_Data.state = NBIOT_ONLINE;
				g_s_nbiot_task_flag = TASK_SUCCESS; //Ϊֹɹ 
				s_onenet_connect_state = S_ONENET_CONNECT_IDLE;
            }
        }
        break;
		
        default:
        {
            s_onenet_connect_state = S_ONENET_CONNECT_IDLE; //״̬عʼ״̬
        }
        break;
    }
}

#if SEND_ACKID_ENABLE
     u16 Send_AckID=0;
#endif

//Onnet״̬
#define S_ONENET_SEND_START     0
#define S_ONENET_SEND_DATA      1
#define S_ONENET_SEND_DATA_R    2

u8 s_onenet_send_state = S_ONENET_SEND_START;
void StartOnenetSendData(void)
{
	s_onenet_send_state = S_ONENET_SEND_START;
}
u8 Send_AckID=0;
void OneNetSendDataMachine(void)
{
//    static u8 s_at_error_count=0; //ATָۼƷʧܴ
    static const char temp_AT_MIPLDISCOVERRSP[] = "AT+MIPLNOTIFY=0,0,3200,0,5750,1,";
    //static char c_AT_MIPLNOTIFY[50+SEND_DATA_LENGTH];//ڴ治㣬ʹù÷ͻ c_AT_NMGS
	
    switch (s_onenet_send_state)
    {
        case S_ONENET_SEND_START:
        {
            s_onenet_send_state = S_ONENET_SEND_DATA; //յݷͣģᱨERRORʱ1SERROR
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        } break;
        
        case S_ONENET_SEND_DATA:// 
        {
             if (!check_timer_1ms())
            {
				if(TASK_IDLE == UartIfIdle(NB_UART_COM))
				{
					 //u16 len = 31; //ATָĳȣݷͳȵλ
					u16 len,i,len_Gprs_Send_Data;
					char len_buffer[6]={0};
					
					c_AT_NMGS[0]=0;//ǿƹ
					strcat(c_AT_NMGS,temp_AT_MIPLDISCOVERRSP);
					len_Gprs_Send_Data=2*Nbiot_Send_Data.len;
					sprintf(len_buffer,"%u",len_Gprs_Send_Data);
					strcat(c_AT_NMGS,len_buffer);
					strcat(c_AT_NMGS,",\"");
					len=strlen(c_AT_NMGS);
					for (i = 0; i < Nbiot_Send_Data.len; i++)//ȡ
					{
						if ((*(Nbiot_Send_Data.buf + i) >> 4) >= 0x0A)
						{
							c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x37;//ַת
						}
						else
						{
							c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x30;//ת 
						}

						if ((*(Nbiot_Send_Data.buf + i) & 0x0F) >= 0x0A)
						{
							c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x37;
						}
						else
						{
							c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x30;
						}
					}
					c_AT_NMGS[len++] = 0;//ֶַֹ                
					strcat(c_AT_NMGS,"\",0,0");           
					if((Sys_data_object.P1.func_cfg_bytes[10] == 0x55)||(Sys_data_object.P3.ProductUploadFlag == 0x55))//ACKϱɹ
					{	
						char strtemp[8];
						if(++Send_AckID==0) 
						{
							Send_AckID=1;  
						}        
						sprintf(strtemp,",%u",Send_AckID);
						strcat(c_AT_NMGS,strtemp);              
						strcat(c_AT_NMGS,"\r");  
						NbiotClearMsg();				
						NbiotUartSend((u8*) c_AT_NMGS,strlen(c_AT_NMGS), cst_AT_No_AT_MIPLNOTIFY_ACKID);
					}
					else
					{
						strcat(c_AT_NMGS,"\r");     
						NbiotClearMsg();				
						NbiotUartSend((u8*) c_AT_NMGS,strlen(c_AT_NMGS), cst_AT_No_AT_MIPLNOTIFY);
					}		     
					
					s_onenet_send_state = S_ONENET_SEND_DATA_R; 
					set_timer_1ms(5*AT_COMMAND_RECEIVE_WAIT_TIME); //ʱϳ5ʱȴ 
				}
            }
        } break; 
        
     case S_ONENET_SEND_DATA_R:
    {
        if (NbiotCheckAtAck() == UART_OK) //ȷӦ
        {
            g_s_nbiot_task_flag = TASK_SUCCESS;
            *Nbiot_Send_Data.state = NBIOT_SUCCESS;
            s_onenet_send_state = S_ONENET_SEND_START;
        }
        else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))//شӦ߶ʱʱ䵽
        {
            *Nbiot_Send_Data.state = NBIOT_ERROR;
            g_s_nbiot_task_flag = TASK_FAIL;
            s_onenet_send_state = S_ONENET_SEND_START;
        }
    } break; 
    default: break;   
    }
}
/***************************************************************************
 * @fun_name    static void NbiotPowerOffMachine()
 * @brief        ػ״̬
 ***************************************************************************/
void NbiotPowerOffMachine(void) //עȻϵػ
{
    //ػ
    static u8 s_at_error_count = 0;
	static const char* c_AT_MIPLCLOSE = "AT+MIPLCLOSE=0\r"; //¼ע
	static const char* c_AT_MIPLDELOBJ = "AT+MIPLDELOBJ=0,3200\r"; //ģඩԴбͷ
	static const char* c_AT_MIPLDEL = "AT+MIPLDELETE=0\r"; //ģͨʵɾ
    static const char* c_AT_CFUN0 = "AT+CFUN=0\r"; //Сģʽ
    static const char* c_AT_NCSEARFCN = "AT+QCSEARFCN=0\r"; //ѱƵ
    static const char* c_AT_CFUN1 = "AT+CFUN=1\r"; //ģʽ
    static const char* c_AT_NETCLOSE = "AT+NCDPCLOSE\r";
	static const u8 c_AT_QPOWD[] = "AT+QPOWD=1\r";
	static const char* c_AT_QICFG0 = "AT+QICFG=\"showlength\",0\r"; //ʾݳ
	
    switch (s_power_off_state)
    {
        case S_POWER_OFF_START:
        {
            s_at_error_count = 0;
            if (Nbiot_Para.net_state == NB_ON_LINE)
            {
				Nbiot_Para.net_state = NB_OFF_LINE;
				Nbiot_Para.coap_state = CONNECT_OFF_LINE;
				Nbiot_Para.udp1_state = CONNECT_OFF_LINE;
				Nbiot_Para.udp2_state = CONNECT_OFF_LINE;
				if(Nbiot_Para.Telecom == SIM_CARD_MOBILE)
				{
                    s_power_off_state = S_UDP_QICFG0;
				}
				else
				{
					s_power_off_state = S_AT_NETCLOSE;
				}
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else
            {
                s_power_off_state = S_AT_CFUN0;
            }
        }
        break;
        case S_AT_MIPLCLOSE://¼ע  //עָΪ5s,2
        {
            if(!check_timer_1ms())
            {
              NbiotUartSend((u8*) c_AT_MIPLCLOSE, strlen(c_AT_MIPLCLOSE), cst_AT_No_AT_MIPLCLOSE);
              s_power_off_state = S_AT_MIPLCLOSE_R;
              set_timer_1ms(5*AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        } break;
                
        case S_AT_MIPLCLOSE_R:
        {
            if (NbiotCheckAtAck() == UART_OK) 
            {
                //ȷӦ
                s_at_error_count = 0;
                s_power_off_state = S_AT_MIPLDELOBJ;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
            } 
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms())) 
            {
                //شӦ߶ʱʱ䵽
               if (++s_at_error_count >= NUM_AT_MIPLCLOSE_ERROR)
                {
                    s_at_error_count = 0;
                    *Nbiot_Send_Data.state = cst_AT_No_AT_MIPLCLOSE;
                    s_power_off_state = S_AT_MIPLDELOBJ;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else 
                {
                    s_power_off_state = S_AT_MIPLCLOSE;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        } break;
                
        case S_AT_MIPLDELOBJ://ģඩԴбͷ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_MIPLDELOBJ, strlen(c_AT_MIPLDELOBJ), cst_AT_No_AT_MIPLDELOBJ);
                s_power_off_state = S_AT_MIPLDELOBJ_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        } break;
                
        case S_AT_MIPLDELOBJ_R:
        {
            if (NbiotCheckAtAck() == UART_OK) 
            {
                //ȷӦ
                s_at_error_count = 0;
                s_power_off_state = S_AT_MIPLDEL;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            } 
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms())) 
            {
                //شӦ߶ʱʱ䵽
               if (++s_at_error_count >= NUM_AT_MIPLDEL_ERROR)
                {
                    s_at_error_count = 0;
                    *Nbiot_Send_Data.state = cst_AT_No_AT_MIPLDELOBJ;
                    s_power_off_state = S_AT_MIPLDEL;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                } 
                else 
                {
                    s_power_off_state = S_AT_MIPLDELOBJ;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        } break;
                
        case S_AT_MIPLDEL://ģඩԴбͷ
        {
            if (!check_timer_1ms()) 
            {
                NbiotUartSend((u8*) c_AT_MIPLDEL, strlen(c_AT_MIPLDEL), cst_AT_No_AT_MIPLDEL);
                s_power_off_state = S_AT_MIPLDEL_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); 
            }
        } break;                
        case S_AT_MIPLDEL_R:
        {
            if (NbiotCheckAtAck() == UART_OK) 
            {
                //ȷӦ
                s_at_error_count = 0;
                s_power_off_state = S_AT_NETCLOSE;    
            } 
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms())) 
            {
                //شӦ߶ʱʱ䵽
                if (++s_at_error_count >= NUM_AT_MIPLDEL_ERROR)
                {
                    s_at_error_count = 0;
                    *Nbiot_Send_Data.state = cst_AT_No_AT_MIPLDEL;
                    s_power_off_state = S_AT_NETCLOSE;
                } 
                else 
                {
                    s_power_off_state = S_AT_MIPLDEL;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        } break;  
        case S_AT_NETCLOSE:
        {
			if(Nbiot_Para.Telecom == SIM_CARD_MOBILE)
			{
				s_power_off_state = S_UDP_QICFG0;
			}
			else
			{
				NbiotUartSend((u8*) c_AT_NETCLOSE, strlen(c_AT_NETCLOSE), cst_AT_No_AT_NETCLOSE);
				set_timer_1s(3);
				s_power_off_state = S_AT_NETCLOSE_R;
			}
        }
        break;

        case S_AT_NETCLOSE_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                //ȷӦ
                s_at_error_count = 0;
				set_timer_1s(1);
                s_power_off_state = S_UDP_QICFG0;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1s()))
            {
                //شӦ߶ʱʱ䵽
                s_at_error_count++;
                if (s_at_error_count >= 2)		//βɹֱӹػ
                {
                    s_at_error_count = 0;
                    s_power_off_state = S_UDP_QICFG0;			//ػ
                }
                else
                {
                    s_power_off_state = S_AT_NETCLOSE;
                }
            }
        }
        break; 
		
		 case S_UDP_QICFG0://ǷʾѡȲ
        {
            if (!check_timer_1ms())
            {
				NbiotUartSend((u8*) c_AT_QICFG0, strlen(c_AT_QICFG0), cst_AT_No_AT_QICFG);//ǷʾѡȲ
                s_power_off_state = S_UDP_QICFG0_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_UDP_QICFG0_R:
        {
            if (NbiotCheckAtAck() == UART_OK)//Ӧȷ-һ
            {
                s_at_error_count = 0;
                s_power_off_state = S_AT_QPOWD;
                set_timer_1s(1);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= 2)
                {
                    s_at_error_count = 0;
					s_power_off_state = S_AT_QPOWD;
					set_timer_1s(1);
                }
                else
                {
                    s_power_off_state = S_UDP_QICFG0;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;
		
		case S_AT_QPOWD:
		{
			if (!check_timer_1s())
			{
				NbiotUartSend((u8*) c_AT_QPOWD, strlen((const char*) c_AT_QPOWD), cst_AT_No_AT_QPOWD);
				set_timer_1s(3);
				s_power_off_state = S_AT_QPOWD_R;
			}
		}
		break;
		
		case S_AT_QPOWD_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                //ȷӦ
                s_at_error_count = 0;				
				set_timer_1s(3);
                s_power_off_state = S_POWER_OFF;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1s()))
            {
                //شӦ߶ʱʱ䵽
                s_at_error_count++;
                if (s_at_error_count >= 2)		//βɹֱӹػ
                {
                    s_at_error_count = 0;
                    s_power_off_state = S_POWER_OFF;			//ֱȥػ
                }
                else
                {
                    s_power_off_state = S_AT_QPOWD;
                }
            }
        }
        break;

        case S_AT_CFUN0://ģСģʽ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CFUN0, strlen((const char*) c_AT_CFUN0), cst_AT_No_AT_CFUN);
                s_power_off_state = S_AT_CFUN0_R;
                set_timer_1ms(2 * AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_AT_CFUN0_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                //ȷӦ
                s_at_error_count = 0;
				set_timer_1ms( AT_COMMAND_SEND_INTERVAL_TIME);
                s_power_off_state = S_AT_NCSEARFCN;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))
            {
                //شӦ߶ʱʱ䵽
                if (++s_at_error_count >= NUM_AT_CFUN_ERROR)
                {
                    s_at_error_count = 0;
                    s_power_off_state = S_AT_NCSEARFCN;
                }
                else
                {
                    s_power_off_state = S_AT_CFUN0;
                    set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
                }
            }
        }
        break;

        case S_AT_NCSEARFCN://Ƶ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_NCSEARFCN, strlen((const char*) c_AT_NCSEARFCN), cst_AT_No_AT_NCSEARFCN);
                s_power_off_state = S_AT_NCSEARFCN_R;
                set_timer_1ms(2 * AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_AT_NCSEARFCN_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                //ȷӦ
                s_at_error_count = 0;
				set_timer_1ms( AT_COMMAND_SEND_INTERVAL_TIME*6);//Ƶʱ3
                s_power_off_state = S_AT_CFUN1;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))
            {
                //شӦ߶ʱʱ䵽
                if (++s_at_error_count >= NUM_AT_NCSEARFCN_ERROR)
                {
                    s_at_error_count = 0;
                    s_power_off_state = S_AT_CFUN1;
                }
                else
                {
                    s_power_off_state = S_AT_NCSEARFCN;
                    set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
                }
            }
        }
        break;

        case S_AT_CFUN1://ģģʽ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CFUN1, strlen((const char*) c_AT_CFUN1), cst_AT_No_AT_CFUN);
                s_power_off_state = S_AT_CFUN1_R;
                set_timer_1ms(2 * AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_AT_CFUN1_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                //ȷӦ
                s_at_error_count = 0;
				set_timer_1s(1);
                s_power_off_state = S_UDP_QICFG0;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))
            {
                //شӦ߶ʱʱ䵽
                if (++s_at_error_count >= NUM_AT_CFUN_ERROR)
                {
                    s_at_error_count = 0;
                    set_timer_1s(1);
					s_power_off_state = S_UDP_QICFG0;
                }
                else
                {
                    s_power_off_state = S_AT_CFUN1;
                    set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
                }
            }
        }
        break;

        case S_POWER_OFF:
        {
			if (!check_timer_1s())
			{
				NB_Power_Disable(); //жϵԴ
				set_timer_1s(1);
				s_power_off_state = S_POWER_OFF_WAIT;
				Nbiot_Para.net_state = NB_OFF_LINE;
				Nbiot_Para.coap_state = CONNECT_OFF_LINE;
				Nbiot_Para.udp1_state = CONNECT_OFF_LINE;
				Nbiot_Para.udp2_state = CONNECT_OFF_LINE;
			}
        }
        break;

        case S_POWER_OFF_WAIT:
        {
            if (!check_timer_1s())
            {
                NbiotPreSleep();
                g_s_nbiot_task_flag = TASK_SUCCESS;
                s_power_off_state = S_START;
            }
        }
        break;

        default:
        {
            s_power_off_state = S_START;
        }
        break;
    }
}

void NbiotReadECLSNRMachine(void)
{
    static u8 s_error_count; //ATָۼƷʧܴ
    static u8 s_ecl_state = S_START;
    switch (s_ecl_state)
    {
        case S_START:
        {
            set_timer_1ms(1000);
            s_error_count = 0;
            s_ecl_state = S_AT_ECL;
        }
        break;

        case S_AT_ECL:
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_NUESTATS, strlen((const char*) c_AT_NUESTATS), cst_AT_No_AT_NUESTATS);
                set_timer_1ms(500);
                s_ecl_state = S_AT_ECL_R;
            }
        }
        break;

        case S_AT_ECL_R:
        {
            if (!check_timer_1ms())
            {
                if (NbiotCheckAtAck() == UART_OK)
                {
                    //ȷӦ
                    *Nbiot_Send_Data.state = ECL_SNR_SUCCESS;
                    g_s_nbiot_task_flag = TASK_SUCCESS;
                    s_ecl_state = S_START;
                }
                else
                {
                    //شӦ߶ʱʱ䵽
                    s_error_count++;
                    if (s_error_count >= 1)
                    {
                        s_error_count = 0;
                        *Nbiot_Send_Data.state = ECL_SNR_ERROR;
                        g_s_nbiot_task_flag = TASK_FAIL;
                        s_ecl_state = S_START;
                    }
                    else
                    {
                        s_ecl_state = S_AT_ECL;
                    }
                }
            }
        }
        break;

        default:
        {
            s_ecl_state = S_START;
        }
        break;
    }
}

/*****************************ONENETӦ·ָ*********************/
static u8 s_onenet_ack_rev_state = S_ONENET_ACKREV_START;

static void StartOnenetAckRev(void)
{
	s_onenet_ack_rev_state = S_ONENET_ACKREV_START;
}
/*******************************************************
NbiotRevAckMachine
ԽյָӦ
*******************************************************/
void NbiotRevAckMachine(void)
{
    static u8 s_error_count; //ATָۼƷʧܴ
    static char c_AT_MIPLWRITE_EXECUTE[30];// =   "AT+MIPLWRITERSP=0,12345,2\r";
    //static char c_AT_MIPLEXECUTE[30];// = "AT+MIPLEXECUTERSP=0,12345,2\r";
    switch (s_onenet_ack_rev_state)
    {
	  case S_ONENET_ACKREV_IDLE:
      {
      } break; 
      case S_ONENET_ACKREV_START:
      {
			set_timer_1ms(1000);
            s_onenet_ack_rev_state = S_ONENET_REPLY_REV_ACKID;
            s_error_count = 0;
      } break;  
         
     case S_ONENET_REPLY_REV_ACKID://Ӧյ
    {
        u8 len;
		char ack_num[10];
		if (!check_timer_1ms())
		{
			memset(ack_num,0,sizeof(ack_num));
			memset(c_AT_MIPLWRITE_EXECUTE,0,sizeof(c_AT_MIPLWRITE_EXECUTE));
			if(ORDER_EXECUTE == NbiotGetOnenetTypeDownOrder())
			{			
				strcpy(c_AT_MIPLWRITE_EXECUTE,"AT+MIPLEXECUTERSP=0,");
			}
			else 
			{
				strcpy(c_AT_MIPLWRITE_EXECUTE,"AT+MIPLWRITERSP=0,");
			}
			NbiotGetWriteAck_num(ack_num);
			strcat(c_AT_MIPLWRITE_EXECUTE,ack_num);
			strcat(c_AT_MIPLWRITE_EXECUTE,",2\r");
			
			len = strlen(c_AT_MIPLWRITE_EXECUTE);
			NbiotUartSend((u8*)c_AT_MIPLWRITE_EXECUTE, len, cst_AT_No_AT_MIPLWRITE);
			set_timer_1ms(5*AT_COMMAND_RECEIVE_WAIT_TIME);
			
			s_onenet_ack_rev_state = S_ONENET_REPLY_REV_ACKID_R; 
		}			
    } break; 
          
    case S_ONENET_REPLY_REV_ACKID_R://Ӧյ--ȴӦ
    {
        if (NbiotCheckAtAck() == UART_OK)
        {
            g_s_nbiot_task_flag = TASK_SUCCESS;
            s_onenet_ack_rev_state = S_ONENET_ACKREV_IDLE;
			SetUartCommRevFlag(); //Ӧд--ݴ
        }
        else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))//شӦ߶ʱʱ䵽
        {
            if (++s_error_count >= NUM_AT_MIPLWRITE_ERROR)
            {
                *Nbiot_Send_Data.state = cst_AT_No_AT_MIPLWRITE;
                g_s_nbiot_task_flag = TASK_FAIL;
                s_onenet_ack_rev_state = S_ONENET_ACKREV_IDLE;
            }
            else
            {
                s_onenet_ack_rev_state = S_ONENET_REPLY_REV_ACKID;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
        }
    }  break;  
    default: break;    
    }
}
/***************************************************************************
 * @fun_name     void PsmWakupMachine(void)
 * @brief        PSM
 ***************************************************************************/
static void Psm_Wakup_Machine(void)
{	
	static const char *c_AT_QSCLK = "AT+QSCLK=0\r"; //ʱر߹ܣNBͨ
	static const char *c_AT_QPING = "AT+QPING=1,\"8.8.8.8\",1,1\r";//+CSCON: 1  ģվѯźֵ
	static const char* c_AT_NCDP_CK = "AT+NMSTATUS?\r"; //ѯźֵ
	
	static u8 s_at_error_count = 0;
	switch(s_psm_wakeup_state)
	{
		//Ӳ:ģ鴦PSMģʽʱ,PSM_EINT(½>100ms)ɽģ PSM 
		case PSM_WKUPSTA_IDLE:
		{
		}
		break;
		case PSM_WKUPSTA_START:
		{  
			 UartInit(NB_UART_COM, BAUD9600, DATA_BIT_8, STOPBIT_1, UART_NONE_PARITY,UART_LPUART_Disable);
			 NB_PSM_WAKE_HIG();
			 set_timer_1ms(500);
			 s_psm_wakeup_state= PSM_WKUPSTA_EINT_LOW;
		}
		break;
		case PSM_WKUPSTA_EINT_LOW:
		{
			if (!check_timer_1ms())
			{
				NB_PSM_WAKE_LOW();
				set_timer_1ms(500);
			   s_psm_wakeup_state= PSM_WKUPSTA_EINT_HIGH;			 
			}
		}
		break;
		case PSM_WKUPSTA_EINT_HIGH:
		{
			if (!check_timer_1ms())
			{ 
				NB_PSM_WAKE_HIG();			
				NbiotUartSend(0, 0, cst_AT_No_AT_NCDP);//ѯ+QLWEVTIND״̬
				set_timer_1ms(5000);//5s,ʱȴ5s,źŲʱ+QLWEVTIND: 6ӦҲܿ,PINGϱʧ
				s_psm_wakeup_state= PSM_WKUPSTA_QLWEVTIND6;
			}			
		}
		break;
        case PSM_WKUPSTA_QLWEVTIND6://˯߻ӻָɹ +QLWEVTIND: 6,
		{
			if (NbiotCheckAtAck() == UART_OK)
			{
				set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
			    s_psm_wakeup_state = PSM_WKUPSTA_QSCLK0;
			}
			else if (!check_timer_1ms())
			{
				s_psm_wakeup_state = PSM_WKUPSTA_WAKE_FAIL;
			}  		
		}
		break;	
		//ģ빤ģʽ
		case PSM_WKUPSTA_QSCLK0:
		{
			if (!check_timer_1ms())
			{
				NbiotUartSend((u8*) c_AT_QSCLK, strlen(c_AT_QSCLK), cst_AT_QSCLK_CLOSE);
				s_at_error_count = 0;
				set_timer_1ms(2000); 
				s_psm_wakeup_state = PSM_WKUPSTA_QSCLK0_R;
			}
		}		
		break;		
		case PSM_WKUPSTA_QSCLK0_R:
		{
		    if (NbiotCheckAtAck() == UART_OK)
            {
				s_at_error_count = 0;
				s_psm_wakeup_state = PSM_WKUPSTA_NPING;//PSM_WKUPSTA_NCDP_CK;
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= 3)
                {
                    s_at_error_count = 0;
					s_psm_wakeup_state = PSM_WKUPSTA_WAKE_FAIL;
                }
                else
                {
                    s_psm_wakeup_state = PSM_WKUPSTA_QSCLK0;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            } 
		}
		break;
		//ӷǷɹ
		case PSM_WKUPSTA_NCDP_CK:
		{
			if (!check_timer_1ms())
			{
				NbiotUartSend((u8*) c_AT_NCDP_CK, strlen((const char*) c_AT_NCDP_CK), cst_AT_No_AT_NCDP_CK);
				set_timer_1s(3);
				s_psm_wakeup_state = PSM_WKUPSTA_NCDP_CK_R;
			}	
		} 
		break;	
		case PSM_WKUPSTA_NCDP_CK_R://ӦӦģ鱣״̬,λǷɹ޹.+NMSTATUS: REGISTERED_AND_OBSERVED
		{
		    if (NbiotCheckAtAck() == UART_OK)
            {
				s_at_error_count = 0;
				s_psm_wakeup_state = PSM_WKUPSTA_NPING;
            }
            else if((!check_timer_1s()))
            {
                s_at_error_count++;
                if (s_at_error_count >=3)
                {
                    s_at_error_count = 0;
					s_psm_wakeup_state = PSM_WKUPSTA_WAKE_FAIL;
                }
                else
                {
                    s_psm_wakeup_state = PSM_WKUPSTA_NCDP_CK;
                }
            }
		} 
		break;
		//PING
		/*+CSCON:1---׼ģվ
		ִAT+QENG=0ѯ---ʱģվӵ״̬²ѯź*/
		case PSM_WKUPSTA_NPING:
		{
			if (!check_timer_1ms())
			{
				NbiotUartSend((u8*) c_AT_QPING, strlen((const char*) c_AT_QPING), cst_AT_No_CSCON1);
				set_timer_1s(5);
				s_psm_wakeup_state = PSM_WKUPSTA_NPING_R;
			}	
		}
		break;
		case PSM_WKUPSTA_NPING_R:
		{
			if (NbiotCheckAtAck() == UART_OK)
            {
				s_at_error_count = 0;
				s_psm_wakeup_state = PSM_WKUPSTA_NUESTATS;
            }
			else if((!check_timer_1s()))
            {
				s_psm_wakeup_state = PSM_WKUPSTA_NUESTATS;
            }
		}
		break;
		//źֵ
		case PSM_WKUPSTA_NUESTATS:
        {
            if (!check_timer_1s())
            {
                NbiotUartSend((u8*) c_AT_NUESTATS, strlen(c_AT_NUESTATS), cst_AT_No_AT_NUESTATS);
                set_timer_1s(2);
                s_psm_wakeup_state = PSM_WKUPSTA_NUESTATS_R;
            }
        }
        break; 
        case PSM_WKUPSTA_NUESTATS_R:
        {
			if (NbiotCheckAtAck() == UART_OK)
			{
				s_psm_wakeup_state = PSM_WKUPSTA_WAKE_SUCCESS;
			}
			else if((!check_timer_1s()))
			{
				s_psm_wakeup_state = PSM_WKUPSTA_WAKE_SUCCESS;
			}
        }
        break;
		case PSM_WKUPSTA_WAKE_SUCCESS:
		{
			psm_model_state = PSM_STATE_WAKE;
			g_s_nbiot_task_flag = TASK_SUCCESS; //ʼɹ
			s_psm_wakeup_state = PSM_WKUPSTA_IDLE;
		}
		break;
		case PSM_WKUPSTA_WAKE_FAIL:
		{
			NbForcePowerOff();
			psm_model_state = PSM_STATE_OUT;
			g_s_nbiot_task_flag = TASK_FAIL; 
			s_psm_wakeup_state = PSM_WKUPSTA_IDLE;
		}
		break;
		default:
		{
			s_psm_wakeup_state = PSM_WKUPSTA_IDLE;
		}
		break;
    }
}

/***************************************************************************
 * @fun_name     void Psm_Sleep_Machine(void)
 * @brief        ͹ģʽ
 ***************************************************************************/
static void Psm_Sleep_Machine(void)
{	
	static const char* c_AT_CPSMS1 = "AT+CPSMS=1\r"; //PSMģʽ
	static const char c_AT_QSCLK1[] = "AT+QSCLK=1\r"; //߹ܣNBͨ
	switch(s_psm_sleep_state)
	{
		case PSM_SLPSTA_IDLE:
		{
		}
		break;
		
        case PSM_SLPSTA_START://ùرջPSMģʽ
        {
			NbiotUartSend((u8*) c_AT_CPSMS1, strlen(c_AT_CPSMS1), cst_AT_No_AT_CPSMS);//ʹPSM
			s_init_state = S_TCP_CPSMS_R;
			set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
			s_psm_sleep_state = PSM_SLPSTA_CPSMS1_R;
        }
        break;

		case PSM_SLPSTA_CPSMS1_R:
		{
			if (NbiotCheckAtAck() == UART_OK)//Ӧȷ-һ
			{
				NbiotUartSend((u8*) c_AT_QSCLK1, strlen(c_AT_QSCLK1), cst_AT_QSCLK_OPEN);
				s_psm_sleep_state = PSM_SLPSTA_WAIT;
				set_timer_1s(30); //ģʽ30sʱȴ
			}
			else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                NbForcePowerOff();
				psm_model_state = PSM_STATE_OUT;
				g_s_nbiot_task_flag = TASK_FAIL;
				s_psm_sleep_state = PSM_SLPSTA_IDLE;
            }
		}	
		break;
		case PSM_SLPSTA_WAIT://ȴӦ +QATSLEEP
		{
		    if (NbiotCheckAtAck() == UART_OK)//Ӧȷ-һ
            {
				psm_model_state = PSM_STATE_SLEEP;
				g_s_nbiot_task_flag = TASK_SUCCESS;
                s_psm_sleep_state = PSM_SLPSTA_IDLE;
            }
            else if ((!check_timer_1s()) || (NbiotCheckAtAck() == UART_ERROR))
            {
				NbForcePowerOff();
				psm_model_state = PSM_STATE_OUT;
				g_s_nbiot_task_flag = TASK_FAIL;
                s_psm_sleep_state = PSM_SLPSTA_IDLE;
            } 
		}
		break;
		case PSM_CHECK_START:
		{
			if(TASK_IDLE == AdcIfIdle())
			{
				AdcStartConvert(PSM_CHECK_CHANNEL, PSM_CHECK_NUM, PSM_CHECK_INTERVAL, &s_psm_adc_result, &s_psm_adc_done);
				s_psm_sleep_state =PSM_CHECK_WAIT;
			}
		}
		break;
		case PSM_CHECK_WAIT:
		{
			 if (TRUE == s_psm_adc_done)
			{
				if (ADC_OK == AdcGetStatus())
				{
					if(s_psm_adc_result>1500)//1V
					{
						NbForcePowerOff();
						psm_model_state = PSM_STATE_OUT;
					}
					g_s_nbiot_task_flag = TASK_SUCCESS;
					s_psm_sleep_state = PSM_SLPSTA_IDLE;
				}
			}
		}
		break;
		default:
		{
			NbForcePowerOff();
			psm_model_state = PSM_STATE_OUT;
			g_s_nbiot_task_flag = TASK_SUCCESS;
			s_psm_sleep_state = PSM_SLPSTA_IDLE;
		}
		break;
    }
}
/***************************************************************************
 * @fun_name    ʱԴ
 * @brief       ڲӿҪΪ˷估ʹ
 ***************************************************************************/
void set_timer_1s(u16 time)
{
    Set100msTimer(TIMER_100MS_NBIOT, time * 10);
}

u16 check_timer_1s(void)
{
    return Check100msTimer(TIMER_100MS_NBIOT);
}

void set_timer_1ms(u16 time)
{
    Set5msTimer(TIMER_5MS_NBIOT, time / 5);
}

u16 check_timer_1ms(void)
{
    return Check5msTimer(TIMER_5MS_NBIOT);
}

/***************************************************************************
 * @fun_name     void StartPowerOffTask()
 * @brief        ػӿ
 ***************************************************************************/
void StartPowerOffTask(void)
{	
    g_s_nbiot_task_flag = TASK_INIT;
    g_s_nbiot_main_state = NBIOT_POWER_OFF;
	s_power_off_state = S_POWER_OFF_START;	
}
//NBǿƹػ
void NbForcePowerOff(void)
{
    NB_Power_Disable();
	Nbiot_Para.net_state = NB_OFF_LINE;
	Nbiot_Para.coap_state = CONNECT_OFF_LINE;
	Nbiot_Para.udp1_state = CONNECT_OFF_LINE;
	Nbiot_Para.udp2_state = CONNECT_OFF_LINE;
    g_s_nbiot_task_flag = TASK_INIT;
    g_s_nbiot_main_state = NBIOT_S_IDLE;
}


void set_clear_ncsearfcn (void)
{
    flag_clear_ncsearfcn =1;
}


void sys_get_three_code (void)
{
//    NbiotGetIMEI(Sys_data_object.P1.NB_module_IMEI_0016);
//    NbiotGetIMSI(Sys_data_object.P1.NB_module_IMSI);
//    NbiotGetICCID(Sys_data_object.P1.SIMCard_ICCID_200A);
}

UNION_4U8TOU32 net_state_data;
u32 sys_get_net_state(void)
{
	s16 s_temp_data=0;
	if(g_s_nbiot_main_state == NBIOT_POWER_INIT)
	{
		net_state_data.data_buf[0] = 1;
		net_state_data.data_buf[1] = s_init_state;
		//net_state_buf[2]CEREG
		//net_state_buf[3]cgatt
	}
	else if(g_s_nbiot_main_state == NBIOT_NET_OPEN)
	{
		net_state_data.data_buf[0] = 2;
		if(Nbiot_Para.Telecom == SIM_CARD_TELECOM)
		{
			net_state_data.data_buf[1] = s_coap_connect_state;
		}
		else
		{
			net_state_data.data_buf[1] = s_onenet_connect_state;
		}
	}
	else if(If_NB_Poweron()==FALSE)
	{
		net_state_data.data_buf[0] = 3;
		//rsrp
		NbiotGetRSRP(&s_temp_data);
		net_state_data.data_buf[1] = -(s_temp_data/10);
		//SNR
		NbiotGetSNR(&s_temp_data);
		if(s_temp_data<0)
		{
			net_state_data.data_buf[2] = (-s_temp_data/10)|0x80;
		}
		else
		{
			net_state_data.data_buf[2] = s_temp_data/10;
		}
		//CSQ
		 NbiotGetCSQ(&net_state_data.data_buf[3]); 
	}
	return net_state_data.datas;
}

void sys_set_net_state(u8 state, u8 data)
{
	net_state_data.data_buf[state] = data;
}
TYP_PSM_STATE getPsmState(void)
{
    return psm_model_state;
}
u16 get_Send_AckID(void)
{
    return Send_AckID;
}		
				
#ifdef	__cplusplus
}
#endif

#endif
